;compiler: avrasm
;dotazy na s.maslan@seznam.cz
;Prehravac 4-kanalovych MOD souboru s 15-ti nebo 31-ti nastroji
;XTAL - 20MHz
;vzorkovani - 22321.42 Hz
;LCD 2 radky 20 znaku s radicem 44780

	.include "m32def.inc"
	.dseg
BitVars:	.byte	1	;bitove promenne
ButtonStack:	.byte	3	;promenne pro tlacitka
BarGraf:	.byte	4	;promenne pro bargrafy (4 kanaly)
ArpeggioStack:	.byte	28	;promenne pro efekt arpeggio
VolSlideStack:	.byte	8	;promenne pro efekt volume slide
PortamentoStack:	.byte	8	;promenne pro efekty portamento
LinePTR:	.byte	3	;ukazatel na aktualni radek v listu (24b)
PatternList:	.byte	128	;zasobnik s poradim listu
PatternPos:	.byte	1	;cislo radku v listu (63-N)
PatternPTR:	.byte	1	;cislo perhravaneho listu
PatternN:	.byte	1	;pocet listu
HighestPatN:	.byte	1	;cislo nejvyssiho listu (jen pro urceni pozice vzorku)
PatIncSpeed:	.byte	10	;delitele pro casovani cteni "not" a efektu
SongSpeed:	.byte	1	;rychlost songu (standardne 6)
SmplsAdress:	.byte	310	;info o kazdem z 31 nebo 15 vzorku v souboru
PlayDataS:	.byte	76	;zasobnik obsahujici informace o prave prehravanem samplu pro kazdy kanal
SongPTR:	.byte	1	;cislo songu v externi pameti
PatternStart:	.byte	2	;zacatek "not" (lisi pro ruzne druhy MODu)
PatList:	.byte	2	;zacatek ople listu v souboru (lisi pro ruzne druhy MODu)
FIFOptr:	.byte	4	;ukazatele WR/RD e FIFO zasobniku
OutputFIFO:	.byte	FIFOsize

	.equ	FIFOsize=1200	;delka = FIFOsize/(4*22.321) [ms]
	;!!!! mimo vystup je vyuzito i pro kopirovani dat z externi pameti do RAM a musi mit minimalne 256B !!!!
	;!!!! velikost musi byt delitenla 4-mi !!!!
			
	.cseg
	.org	$000	;inicializace
	jmp	Init
	.org	$008	;preruseni timeru 2 pro cteni tlacidel
	jmp	CteniTlacitek
	.org	$00E	;preruseni timeru 1 pro time out pri prenosu dat pres COM
	rjmp	RecData
	.org	$014	;preruseni timeru 0 pro vystup FIFO registru
	
	;preruseni play casovace - vezme data z FIFO registru z adresy RD a posle je na DAC
	;tento podprogram musi byt co nejkratsi, takze v dusledku optimalizace dost neprehledny :-)
	;!!! push/pop je nahrazeno in/out do nevyuzitych registru casovace 1 a jinde se s nimi nesmi manipulovat (usetri se 4 cykly :-)!!!
	out	ocr1bh,R16	;misto push
	out	ocr1bl,R30	;misto push
	in	R16,sreg	;misto push
	out	icr1h,R31	;misto push
	out	icr1l,R16	;misto push

	lds	R30,FIFOptr	;nacteni RD adresy
	lds	R31,FIFOptr+1
	;tady je treba vybrat cast kodu pro TDA1543(I2S) nebo TDA1545("japonsky standard" casove multiplexovany, doplnkovy tvar (standard jak noha - prakticky jde o I2S, kde je signal WS zpozden o 1 hodinovy cykl))

	;generovani sbernice pro DAC TDA1545
	;PS.: nic nemazat - je to presne nacasovano a kratsi uz to byt nemuze
	;pro DAC TDA1545
	ld	R16,Z+
	out	spdr,R16	;high byte levy
	;15 cyklu pauza
	ldi	R16,5
ISPdel1:	dec	R16
	brne	ISPDel1
	;
	ld	R16,Z+
	out	spdr,R16	;low byte levy
	;pauza 15 cyklu
	ldi	R16,4
ISPdel2:	dec	R16
	brne	ISPdel2
	cpi	R30,low(OutputFIFO+FIFOsize-2)
	ldi	R16,high(OutputFIFO+FIFOsize-2)
	cpc	R31,R16
	;
	ld	R16,Z+
	sbi	portb,2	;negovat WS pin
	out	spdr,R16	;high byte pravy
	ld	R16,Z+
	;pauza 15 cyklu
	brne	NeKonec
	ldi	R30,low(OutputFIFO)
	ldi	R31,high(OutputFIFO)
	rjmp	JoKonec
NeKonec:	nop
	nop
	nop
JoKOnec:	sts	FIFOptr,R30
	sts	FIFOptr+1,R31
	adiw	R30,0	;2 cykly
	adiw	R30,0	;2 cykly
	adiw	R30,0	;2 cykly
	;
	out	spdr,R16	;low byte pravy
	;pauza 15 cyklu
	adiw	R30,0	;2 cykly
	adiw	R30,0	;2 cykly
	adiw	R30,0	;2 cykly
	adiw	R30,0	;2 cykly
	adiw	R30,0	;2 cykly
	in	R31,icr1h	;misto pop
	in	R16,icr1l	;misto pop
	out	sreg,R16	;misto pop
	in	R16,ocr1bh	;misto pop
	in	R30,ocr1bl	;misto pop
	;
	cbi	portb,2	;negovat pin WS
	
	;generovani I2S pro DAC TDA1543
	;PS.: nic nemazat - je to presne nacasovano a kratsi uz to byt nemuze
;	ld	R16,Z+
;	out	spdr,R16
	;15 cyklu pauza
;	ldi	R16,5
;ISPdel1:	dec	R16
;	brne	ISPdel1
	;
;	ld	R16,Z+
;	out	spdr,R16
	;12 cyklu pauza
;	ldi	R16,3
;ISPdel2:	dec	R16
;	brne	ISPdel2
;	cpi	R30,low(OutputFIFO+FIFOsize-2)
;	ldi	R16,high(OutputFIFO+FIFOsize-2)
;	cpc	R31,R16
	;
;	sbi	portb,2
;	nop
;	ld	R16,Z+
;	out	spdr,R16
;	ld	R16,Z+
	;pauza 15 cyklu
;	brne	NeKonec
;	ldi	R30,low(OutputFIFO)
;	ldi	R31,high(OutputFIFO)
;	rjmp	JoKonec
;NeKonec:	nop
;	nop
;	nop
;JoKOnec:	sts	FIFOptr,R30
;	sts	FIFOptr+1,R31
;	adiw	R30,0	;2 cykly
;	adiw	R30,0	;2 cykly
;	adiw	R30,0	;2 cykly
	;
;	out	spdr,R16
	;pauza 15 cyklu
;	adiw	R30,0	;2 cykly
;	adiw	R30,0	;2 cykly
;	adiw	R30,0	;2 cykly
;	nop
;	in	R31,icr1h	;misto pop
;	in	R16,icr1l	;misto pop
;	out	sreg,R16	;misto pop
;	in	R16,ocr1bh	;misto pop
;	in	R30,ocr1bl	;misto pop
;	cbi	portb,2
	reti
	
;--------------- adresy songu v externi pameti ve rormatu A0-A7, A8-A15, A16-19 -----------------------------
;priklad vypoctu:
;adresa = 500000
;A16-19 = adresa/65536 = 7 (zbytek 41248)
;A8-15  = 41248/256 = 161 (zbytek 32)
;A0-7   = 32
;	.db	32,161,7

	;adresy zacatku jednotlivych souboru v ext. pameti, posledni musi byt konec posledniho songu nebo cele pamet (to radeji ne, protoze by nacitani dlouho trvalo)
Songs:	.db	0,0,0	;song 1 od adresy 0
	.db	103,147,5	;song 2 od adresy 365415
	.db	169,92,6	;song 3 od adresy 416937
	.db	167,84,7	;song 4 od adresy 480423
	.db	187,14,8
	.db	65,240,9
	.db	25,78,12
	.db	240,249,13
	.db	255,255,15	;konec posledniho songu nebo cele pameti

	.equ	SongN=8	;pocet skladeb
	
;--------------- time out obsluha preruseni -------------------------------------------------
RecData:	ser	R25
	reti
	
;--------------- cteni tlacitek - obsluha preruseni, vystup FIFO do DAC blokovan ------------
CteniTlacitek:	push	R20
	push	R19
	push	R17
	push	R16
	in	R16,sreg
	push	R16
	in	R16,ddra
	push	R16
	in	R16,porta
	push	R16
	;
	ldi	R16,0
	out	ddra,R16
	ldi	R16,255
	out	porta,R16
	sbi	ddrd,2
	nop
	nop
	nop
	nop
	in	R20,pina	;nacteni stavu na porta
	;vyhodnoceni zmen
	lds	R16,ButtonStack
	sts	ButtonStack,R20
	eor	R16,R20
	com	R20	;v R20 stavy (pri podrzeni tlacitka) jednotlivych tlacitek
	and	R16,R20
	mov	R19,R16	;v R19 zmeny (z nestiknuteho do stisknuteho stavu) jednotlivych tlacitek
	
	cpi	R20,0
	brne	NeNicStiskl
	rjmp	NicStiskl	;preskoc, kdyz nic neni stisknuto
	;obsluha pri stisku tlacitka (zmeny)
NeNicStiskl:	bst	R19,1	;dalsi song
	brtc	NeIncSongZ
	rcall	IncSongPTR
	ldi	R16,1
	sts	ButtonStack+2,R16
	rjmp	NecoStiskl
NeIncSongZ:	bst	R19,0	;predchozi song
	brtc	NeDecSongZ
	rcall	DecSongPTR
	ldi	R16,1
	sts	ButtonStack+2,R16
	rjmp	NecoStiskl
NeDecSongZ:	bst	R19,3	;dalsi list
	brtc	NeIncListZ
	rcall	IncListPTR
	ldi	R16,1
	sts	ButtonStack+2,R16
	rjmp	NecoStiskl
NeIncListZ:	bst	R19,2	;predchozi list
	brtc	NeDecListZ
	rcall	DecListPTR
	ldi	R16,1
	sts	ButtonStack+2,R16
	rjmp	NecoStiskl
NeDecListZ:	bst	R19,4	;nacist song z USARTu
	brtc	NeLoadUSARTZ
	rcall	LoadSongUSART
	ldi	R16,1
	sts	ButtonStack+2,R16
	rjmp	NecoStiskl
NeLoadUSARTZ:	bst	R19,5	;START / STOP
	brtc	NeStartStopZ
	rcall	StartStop
	ldi	R16,1
	sts	ButtonStack+2,R16
	rjmp	NecoStiskl
NeStartStopZ:	rjmp	StavySet

	rjmp	StavySet

	;obsluha pri drzeni tlacitka (stavy)
StavySet:	lds	R16,ButtonStack+1
	dec	R16
	sts	ButtonStack+1,R16
	breq	ButAutoDelayY
	rjmp	NicStiskl
ButAutoDelayY:	inc	R16
	sts	ButtonStack+1,R16
	;uz zjistovat
	bst	R20,1
	brtc	NeIncSongS	;dalis song
	ldi	R17,12
	rcall	AutoSpeedR
	brtc	NeIncSongS
	rcall	IncSongPTR
	rjmp	NecoStisklS
NeIncSongS:	bst	R20,0
	brtc	NeDecSongS	;predchozi song
	ldi	R17,12
	rcall	AutoSpeedR
	brtc	NeDecSongS
	rcall	DecSongPTR
	rjmp	NecoStisklS
NeDecSongS:	bst	R20,3
	brtc	NeIncListS	;dalsi list
	ldi	R17,5
	rcall	AutoSpeedR
	brtc	NeIncListS
	rcall	IncListPTR
	rjmp	NecoStisklS
NeIncListS:	bst	R20,2
	brtc	NeDecListS	;predchozi list
	ldi	R17,5
	rcall	AutoSpeedR
	brtc	NeDecListS
	rcall	DecListPTR
	rjmp	NecoStisklS
NeDecListS:	rjmp	NicStiskl

NecoStiskl:	ldi	R16,15
	sts	ButtonStack+1,R16

NecoStisklS:	lds	R16,BitVars
	bst	R16,7
	brts	SSkey
	bst	R16,5
	brts	SSkey
	ori	R16,0b00010000	;zajisti, ze pri pauze dojde k zobrazeni pri zmene listu/songu
SSkey:	andi	R16,0b11011111
	sts	BitVars,R16
NicStiskl:	;nastavit porta do norm. stavu
	cbi	ddrd,2
	;
	pop	R16
	out	porta,R16
	pop	R16
	out	ddra,R16
	pop	R16
	out	sreg,R16
	pop	R16
	pop	R17
	pop	R19
	pop	R20
	reti
	;dalsi song
IncSongPTR:	lds	R16,BitVars
	andi	R16,0b10000000
	ori	R16,0b00000001
	sts	BitVars,R16
	lds	R16,SongPTR
	inc	R16
	cpi	R16,SongN
	brne	NullSongInc
	clr	R16
NullSongInc:	sts	SongPTR,R16
	ret
	;predchozi song
DecSongPTR:	lds	R16,BitVars
	andi	R16,0b10000000
	ori	R16,0b00000001
	sts	BitVars,R16
	lds	R16,SongPTR
	dec	R16
	cpi	R16,255
	brne	NullSongDec
	ldi	R16,(SongN-1)
NullSongDec:	sts	SongPTR,R16
	ret
	;dalsi list
IncListPTR:	ldi	R16,1	;pri prvnim pruchodu testem na dalsi list se nacte
	sts	PatternPos,R16
	lds	R16,PatIncSpeed+2
	lds	R17,PatIncSpeed+3
	subi	R16,1
	sbci	R17,0
	sts	PatIncSpeed,R16
	sts	PatIncSpeed+1,R17
	lds	R17,PatternPTR
	inc	R17
	lds	R16,PatternN
	cp	R16,R17
	brne	NeIncListMax
	dec	R17
NeIncListMax:	sts	PatternPTR,R17
	lds	R16,BitVars
	ori	R16,0b00001000
	sts	BitVars,R16
	ret
	;min. list
DecListPTR:	ldi	R16,1
	sts	PatternPos,R16
	lds	R16,PatIncSpeed+2
	lds	R17,PatIncSpeed+3
	subi	R16,1
	sbci	R17,0
	sts	PatIncSpeed,R16
	sts	PatIncSpeed+1,R17
	lds	R17,PatternPTR
	dec	R17
	cpi	R17,255
	brne	NeDecListMax
	ldi	R17,0
NeDecListMax:	sts	PatternPTR,R17
	lds	R16,BitVars
	ori	R16,0b00001000
	sts	BitVars,R16
	ret
	;nacist data z USARTu
LoadSongUSART:	lds	R16,BitVars
	andi	R16,0b10000000
	ori	R16,0b01000001
	sts	BitVars,R16
	ret
	;start/stop
StartStop:	lds	R16,BitVars
	ldi	R17,0b10000000
	eor	R16,R17
	ori	R16,0b00100000
	sts	BitVars,R16
	ret
	;rychlozt automatickeho pricitani pri drzeni
AutoSpeedR:	clt
	lds	R16,ButtonStack+2
	dec	R16
	sts	ButtonStack+2,R16
	brne	NeAutoSpeed
	sts	ButtonStack+2,R17
	set
NeAutoSpeed:	ret


	;inicializace LCD jako 2 radkovy
LCDinit:	ldi	R16,0b11111111
	out	ddrc,R16
	rcall	ByteToLCDst
	ldi	R16,0b00111000
	rcall	ByteToLCD
	ldi	R16,0b00001100
	rcall	ByteToLCD
	rcall	GenerovatZnaky
	ldi	R16,0b10000000
	rcall	ByteToLCD
	ldi	R16,0b00000000
	out	ddrc,R16
	ret
	;posle byte LCD a generuje zpozdeni neco pres 40us	
ByteToLCD:	out	portc,R16
	sbi	portb,0
	nop
	cbi	portb,0
	ldi	R16,220
ByteToLCDL1:	dec	R16
	nop
	brne	ByteToLCDL1
	ret
	;jen zpozdeni po zapnuti (nektere LCD se nechtely inicializovat)
ByteToLCDst:	ldi	R17,10
	ldi	R16,0	
ByteToLCDst1:	dec	R16
	brne	ByteToLCDst1
	dec	R17
	brne	ByteToLCDst1
	ret

	;vygeneruje znaky pro bargrafy do CGRAM
GenerovatZnaky:	ldi	R19,0b01000000
	ldi	R17,8
	ldi	R18,1
GenZnaky1:	cbi	portb,1
	mov	R16,R19
	inc	R19
	rcall	ByteToLCD
	sbi	portb,1
	ldi	R16,0b00000000
	cp	R18,R17
	brcs	NeBlack
	ldi	R16,0b00011111
NeBlack:	rcall	ByteToLCD
	inc	R18
	cpi	R18,9
	brne	DalsiBarCh
	ldi	R18,1
	dec	R17
DalsiBarCh:	cpi	R19,0b10000000
	brne	GenZnaky1
	cbi	portb,1
	ret
	
RAMprotect:	sbi	portb,4	;RAM CS do log.1
	;zpozdeni kvuli RC konstante
	ldi	R16,180
	ldi	R17,0
	ldi	R18,0
RPdel1:	dec	R18
	brne	RPdel1
	dec	R17
	brne	RPdel1
	dec	R16
	brne	RPdel1
	ret	

;---------------	Inicializace --------------------------------------------------------------
Init:	;pocatecni nastaveni portu a pinu
	ldi	R16,0b11111111
	out	ddra,R16
	ldi	R16,0b11110011
	out	ddrd,R16
	ldi	R16,0b11111111
	out	ddrb,R16
	ldi	R16,0b00000000
	out	ddrc,R16
	cbi	portb,4	;RAM CS
	sbi	portd,7	;EPROM OE
	sbi	portb,3	;RAM WR
	sbi	portd,4	;RAM OE
	sbi	portd,6	;A16-A19 buffer CK
	sbi	portd,5	;A8-A15 buffer CK
	cbi	portb,0	;LCD E
	cbi	portb,1	;LCD RS
	cbi	portd,2	;com. tlacitka
	;stack ptr
	ldi	R16,high(RAMEND)
	out	sph,R16	;nastav SP na konec SRAM
	ldi	R16,low(RAMEND)
	out	spl,R16	;nastav SP na konec SRAM
	;FIFO out timer 0
	ldi	R16,0b00001011	;timer 0: 22321,42 Hz
	out	tccr0,R16
	ldi	R16,13	;timer 0: 22321,42 Hz
	out	ocr0,R16
	;timer 2 pro cteni tlacidel
	ldi	R16,0b01000111
	out	tccr2,R16
	ldi	R16,255	;timer 2: asi 75Hz
	out	ocr2,R16
	;time out timer 1
	ldi	R16,0b00000000
	out	tccr1a,R16
	ldi	R16,0b00001101	;delitel 1024
	out	tccr1b,R16
	;SPI rozhrani pro vytvoreni I2S sbernice	
	ldi	R16,0b01010000
	out	spcr,R16
	ldi	R16,0b00000001
	out	spsr,R16
	;USART pro prijem dat, 115200bd, 8bit, 1 stop, bez parity
	ldi	R16,0b01100010
	out	ucsra,R16
	ldi	R16,0b00011000
	out	ucsrb,R16
	ldi	R16,0b10000110
	out	ucsrc,R16
	ldi	R16,0b00000000
	out	ubrrh,R16
	ldi	R16,21	;115200bd
	out	ubrrl,R16
	;RAM init
	rcall	RAMprotect
	;pro zjistovani zmen tlacitek
	ser	R16	;pocatecni stav
	sts	ButtonStack,R16
	;init. LCD
	rcall	LCDinit	;init LCD jako 2 radkovy
	;
	ldi	R16,0b11000000	;po zapnuti cist z RAM
	sts	BitVars,R16
	;
	ldi	R16,0	;ukazatel na 1. song v externi pameti
	sts	SongPTR,R16

LdNewSong:	rcall	NewSong
	
;--------------- v nasledujicim kodu se generuje vlastni zvuk (nacitani vzorku z RAM a provadeni efektu)------------------------------ 
	;vysledek se uklada do FIFO na adresu WR v zasobniku FIFOptr
	;tady se resi START/STOP prehravani
CountSMPL:	cli
	lds	R16,BitVars
	in	R17,timsk
	bst	R16,7
	bld	R17,1
	out	timsk,R17
	bst	R16,4
	brtc	NeStopChange
	lds	R16,BitVars
	andi	R16,0b11101111
	sts	BitVars,R16
	bst	R16,0
	brtc	NeNewStop
	rcall	NewSong
NeNewStop:	rcall	LCDwriteStatus
	cli
	;tady se zjistuje kolik mista je ve FIFO
NeStopChange:	lds	R30,FIFOptr	;read
	lds	R31,FIFOptr+1
	lds	R28,FIFOptr+2	;write
	lds	R29,FIFOptr+3
	sub	R30,R28
	sbc	R31,R29
	brcc	JeTamMisto
	ldi	R26,low(FIFOsize-1)
	ldi	R27,high(FIFOsize-1)
	add	R30,R26
	adc	R31,R27
JeTamMisto:	cpi	R30,8	;kdyz je alespon 8 bytu mista, povoli se vypocet dalsicho vzorku
	clr	R16
	cpc	R31,R16
	brcc	NeDohnal
	rjmp	UzDohnal	;nepocitat vzorek
NeDohnal:	sei
	;nedriv se deli vzorkovaci frekvecne 8x - nasledujici instrukce pak v prumeru zaberou 1/8 casu 
	lds	R16,PatIncSpeed+5
	inc	R16
	sts	PatIncSpeed+5,R16
	cpi	R16,8
	breq	DalsiRadekNot
	rjmp	NeDalsiRadekNot	;7 z 8 pruchodu se preskakuji dalsi vypocty az k vlastnimu vypoctu vzorku
DalsiRadekNot:	clr	R16
	sts	PatIncSpeed+5,R16
	;toto deleni 8x ma stejnou funkci jako predchozi - usetrit cas, tentokdat instrukce zabiraji jen 1/64 casu
	lds	R16,PatIncSpeed+6
	inc	R16
	sts	PatIncSpeed+6,R16
	cpi	R16,8
	breq	CanDoEfekty
	rjmp	NotCanDoEfekty	;7 z 8 pruchodu se preskakuji vsechny dalsi instrukce az k testu, kde se zjistuje jesl se ma cist dalsi radek not 
CanDoEfekty:	clr	R16
	sts	PatIncSpeed+6,R16
	;test, jestli se ma nacist dali song
	lds	R16,BitVars
	bst	R16,0
	brtc	NeJinejSong
	cli
	rjmp	LdNewSong	;nahrat dalsi song
NeJinejSong:	;dalsi delitel, pro vykresleni bargrafu (kresli se asi 70x/s)
	lds	R16,PatIncSpeed+7
	inc	R16
	sts	PatIncSpeed+7,R16
	cpi	R16,5
	brne	NeBarGs
	clr	R16
	sts	PatIncSpeed+7,R16
	rcall	WriteBarGraf
NeBarGs:	;vypocet efektu volume slide (asi 350x/s)
	ldi	R30,low(VolSlideStack)
	ldi	R31,high(VolSlideStack)	
	ldi	R28,low(PlayDataS+7)
	ldi	R29,high(PlayDataS+7)
	ldi	R25,4	;4 kanaly
	
SlideVolumeC:	ld	R0,Y+
	ld	R1,Y+
	sbiw	R28,2
	ld	R16,Z+
	ld	R17,Z+
	bst	R17,7
	brts	VolumeSlideUp
	;slide down
	sub	R0,R16
	sbc	R1,R17
	brcc	NeVSlideDownZ
	clr	R0
	clr	R1
NeVSlideDownZ:	rjmp	VolumeSlideOk
VolumeSlideUp:	;slide up
	andi	R17,0b01111111
	add	R0,R16
	adc	R1,R17
	ldi	R16,255
	cp	R1,R16
	brcs	VolumeSlideOk
	clr	R0
	ser	R16
	mov	R1,R16
VolumeSlideOk:	st	Y+,R0
	st	Y+,R1
	adiw	R28,17
	dec	R25
	brne	SlideVolumeC
	;dalsi delitel pro efekt arpeggio (asi 50x/s)
	lds	R16,PatIncSpeed+8
	inc	R16
	sts	PatIncSpeed+8,R16
	cpi	R16,7
	brne	NeArpeggioDiv
	ldi	R16,0
	sts	PatIncSpeed+8,R16
	;
	ldi	R30,low(ArpeggioStack)
	ldi	R31,high(ArpeggioStack)	
	ldi	R28,low(PlayDataS+3)
	ldi	R29,high(PlayDataS+3)
	ldi	R25,4	;4 kanaly
	
NextChanArp:	ld	R20,Z+
	cpi	R20,0
	breq	NedelatArpeggio	;neaktivni arpeggio
	;vyber mezi zakladnim, 1. a 2. kmitoctem arpeggia
	cpi	R20,1
	brne	NeZaklArp1
	ld	R16,Z+
	ld	R17,Z+
	clr	R18
	st	Y+,R18
	st	Y+,R16
	st	Y+,R17
	sbiw	R28,3
	sbiw	R30,3
	ldi	R20,2
	st	Z+,R20
	rjmp	NedelatArpeggio
NeZaklArp1:	cpi	R20,2
	brne	NeZaklArp2
	adiw	R30,2
	ld	R16,Z+
	ld	R17,Z+
	clr	R18
	st	Y+,R18
	st	Y+,R16
	st	Y+,R17
	sbiw	R28,3
	sbiw	R30,5
	ldi	R20,3
	st	Z+,R20
	rjmp	NedelatArpeggio
NeZaklArp2:	cpi	R20,3
	brne	NedelatArpeggio
	adiw	R30,4
	ld	R16,Z+
	ld	R17,Z+
	clr	R18
	st	Y+,R18
	st	Y+,R16
	st	Y+,R17
	sbiw	R28,3
	sbiw	R30,7
	ldi	R20,1
	st	Z+,R20
NedelatArpeggio:	adiw	R30,6
	adiw	R28,19
	dec	R25
	brne	NextChanArp
	;dalsi deleni, pro portamento (asi 32x/s)
NeArpeggioDiv:	lds	R16,PatIncSpeed+9
	inc	R16
	sts	PatIncSpeed+9,R16
	cpi	R16,10
	breq	PortamentoDS
	rjmp	NePortamentoDS
PortamentoDS:	clr	R16
	sts	PatIncSpeed+9,R16
	;pocitat portamento
	ldi	R30,low(PortamentoStack)
	ldi	R31,high(PortamentoStack)	
	ldi	R28,low(PlayDataS+3)
	ldi	R29,high(PlayDataS+3)
	ldi	R26,4	;4 kanaly
	
NextChanPort:	ld	R23,Z+	;nacist portam. konst.
	ld	R24,Z+
	mov	R25,R24
	ldi	R16,255	;16777215
	ldi	R17,255
	ldi	R18,255
	ld	R19,Y+	;nacist puvodni frekvenci
	ld	R20,Y+
	ld	R21,Y+
	bst	R24,5
	brtc	NePortTed	;kdyz neni portamento aktivni
	lsr	R21	;delit ji 2x (pro vyssi rozliseni po deleni)
	ror	R20
	ror	R19
	rcall	Div24u	;prevest na periodu

	bst	R24,7
	brts	PortUpCo	;provest zmenu periody
	;odecitani
	andi	R24,0b00011111
	sub	R16,R23
	sbc	R17,R24
	sbci	R18,0
	rjmp	PortComCo
	;pricitani
PortUpCo:	andi	R24,0b00011111
	add	R16,R23
	adc	R17,R24
	clr	R23
	adc	R18,R23
PortComCo:	mov	R19,R16
	mov	R20,R17
	mov	R21,R18
	ldi	R16,255	;16777215
	ldi	R17,255
	ldi	R18,255
	rcall	Div24u	;prevest zpet na frekvenci
	lsl	R16	;nasobit ji 2x
	rol	R17
	rol	R18
	;bylo to tone-portamento?
	bst	R25,6
	brtc	NeTonePortC
	;ano, test jestli bylo dosazeno cilove frekvence, kdyz ano, tak zastavit portamento
	sbiw	R28,5
	ld	R19,Y+
	ld	R20,Y+
	adiw	R28,3
	bst	R25,7
	brts	TPortCo
	;pri zvysovani
	cp	R17,R19
	cpc	R18,R20
	brcs	TportComCo
	clr	R16
	mov	R17,R19
	mov	R18,R20
	andi	R25,0b00011111	;zastavit tone portamento
	rjmp	TportComCo
TPortCo:	;pri snizovani
	cp	R19,R17
	cpc	R20,R18
	brcs	TportComCo
	clr	R16
	mov	R17,R19
	mov	R18,R20
	andi	R25,0b00011111	;zastavit tone portamento
TportComCo:	sbiw	R30,1
	st	Z+,R25
	;
NeTonePortC:	sbiw	R28,3
	st	Y+,R16	;ulozit zpet novou frekvenci
	st	Y+,R17
	st	Y+,R18
NePortTed:	adiw	R28,16

	dec	R26
	breq	NePortamentoDS
	rjmp	NextChanPort

NePortamentoDS:	;konec efektu

	;test jesli se ma cist dalsi radek not
NotCanDoEfekty:	cli
	lds	R30,PatIncSpeed
	lds	R31,PatIncSpeed+1
	adiw	R30,1
	sts	PatIncSpeed,R30
	sts	PatIncSpeed+1,R31
	lds	R18,PatIncSpeed+2
	lds	R19,PatIncSpeed+3
	cp	R30,R18
	cpc	R31,R19
	brne	NeDalsiRadekNot
	;dalsi noty
	clr	R16
	sts	PatIncSpeed,R16
	sts	PatIncSpeed+1,R16
	sei
	rcall	Takt	;nacist dalsi radek not
NeDalsiRadekNot:	sei
;--------------- tady se podle dat v PlayDataS zasobniku nacitaji vlastni zvukova data --------
	;a provadi se mix kanalu + par dalsich veci
	;nejdrive definice par promennych
	;PS.: jestli se nekomu zda program v teto casti nelogicky rozmisteny, 
	;     zmateny apod., tak je to jen kvuli dosazeni maximalni rychlosti 
	ldi	R28,low(PlayDataS)
	ldi	R29,high(PlayDataS)
	ldi	R30,low(BarGraf)
	ldi	R31,high(BarGraf)
	ldi	R20,4	;4 kanaly
	ldi	R21,0b10000000	;pro prevod znaminkovych/neznaminkovych cisel
	clr	R22	;porad 0 (zase pro zrychleni)
	clr	R13	;levy kanal
	clr	R14
	clr	R15
	clr	R10	;pravy kanal
	clr	R11
	clr	R12
	;prehrav. rychlost
NextChannelP:	adiw	R28,4	;preskocit par nepotrebnych bytu
	ld	R16,Y+	;konstanta pro generovani tonu (frekvence)
	ld	R17,Y+
	
	adiw	R28,2	;zase par zde nepotrebnych bytu

	ld	R19,Y+	;hlasitost
	
	ld	R3,Y+	;pozice vzorku
	ld	R0,Y+
	ld	R1,Y+
	ld	R2,Y+
	ld	R4,Y+	;konec vzorku
	ld	R5,Y+
	ld	R6,Y+
	cp	R0,R4	;zjistit, jestli uz je konec samplu
	cpc	R1,R5
	cpc	R2,R6
	brlo	NeKonecPl
	;uz jsem na konci
	ld	R4,Y+	;nahrat start loop vzorku
	ld	R5,Y+
	ld	R6,Y+
	bst	R6,7
	brtc	LoopSmpl	;ma se cyklit?
	;ne
	;plynuly konec samplu (jinak to dost lupne pri zacatku dalsiho)
	;predevsim jde o to, aby perd prehratim dalsiho bylo napeti 0
;	subi	R19,32
;	brcc	NeNullVolSD
;	clr	R19	
NeNullVolSD:	sbiw	R28,11	;navrat na pozici vzorku
	st	Y+,R19	;ulozit hlasitost
	rjmp	JoKonecPl
	;ano
LoopSmpl:	clr	R3
	movw	R0,R4
	mov	R2,R6
	sbiw	R28,3
	;pricist konstantu frekvence
NeKonecPl:	add	R3,R16
	adc	R0,R17
	adc	R1,R22	;0
	adc	R2,R22	;0
	;ulozit novou hodnotu do zasobniku
	sbiw	R28,7	;navrat na pozici vzorku
JoKonecPl:	st	Y+,R3
	st	Y+,R0
	st	Y+,R1
	st	Y+,R2
	adiw	R28,6
	;nacist byte z RAM
	out	porta,R2
	cbi	portd,5
	sbi	portd,5
	out	porta,R1
	cbi	portd,6
	sbi	portd,6
	out	porta,R0
	;adresu na dalsi vzorek v RAM
	ldi	R17,1
	add	R0,R17
	adc	R1,R22	;0
	adc	R2,R22	;0
	;
	in	R18,pinc	;nacist 1. byte
	;poslat adresu 2. bytu ven
	out	porta,R2
	cbi	portd,5
	sbi	portd,5
	out	porta,R1
	cbi	portd,6
	sbi	portd,6
	out	porta,R0
	nop
	eor	R18,R21	;prevest 1.byte na neznaminkovy
	mov	R16,R18
	in	R17,pinc	;precist ho
	eor	R17,R21	;prevest 2.byte na neznamenkovy
	;linearni interpolace vzorku (bez ni to zni hrozne :-)
	cp	R17,R18
	brcs	Sestupna	;zjistis jestli jde o sest. nebo vzest. "hranu" signalu
	;sestupna "hrana"
	sub	R17,R18
	mul	R17,R3
	add	R18,R1
	rjmp	Hotovo
Sestupna:	sub	R16,R17
	mul	R16,R3
	sub	R18,R1
Hotovo:	;vypocet hlasitost (od ted je singal v 16-bitech)
	eor	R18,R21
	mulsu	R18,R19
	eor	R1,R21
	;vystup do mixeru tady se 4 kanaly mixuji na 2 
	;vyber levy/pravy
	cpi	R20,1
	breq	PravyK
	cpi	R20,4
	breq	PravyK
	;levy
	add	R13,R0
	adc	R14,R1
	adc	R15,R22	;0
	rjmp	PLkanOk
	;pravy
PravyK:	add	R10,R0
	adc	R11,R1
	adc	R12,R22	;0	
	;
PLkanOk:	ld	R16,Z	;tady se zaznamenava spickova hodnota pro bargraf pro kazdy kanal
	cp	R16,R1
	brcc	NeVicBars
	mov	R16,R1
NeVicBars:	st	Z+,R16
	;dalsi kanal
	dec	R20
	breq	NeNextChannelP
	rjmp	NextChannelP
NeNextChannelP:	;hotovo, uz pouze deleni 2 (prumer)
	lsr	R15
	ror	R14
	ror	R13
	lsr	R12
	ror	R11
	ror	R10
	eor	R14,R21	;a prevod do znamenkoveho tvaru
	eor	R11,R21	;a ro 2 kanal
	;test, zde uz je dosazeni konce FIFO pameti
	cli
	lds	R28,FIFOptr+2	;na WR adresu
	lds	R29,FIFOptr+3
	st	Y+,R14	;save data byte levy
	st	Y+,R13
	st	Y+,R11	;save data byte pravy
	st	Y+,R10
	cpi	R28,low(OutputFIFO+FIFOsize)
	ldi	R16,high(OutputFIFO+FIFOsize)
	cpc	R29,R16
	brne	PresMaxW
	ldi	R28,low(OutputFIFO)	;navrat na zacatek
	ldi	R29,high(OutputFIFO)
PresMaxW:	sts	FIFOptr+2,R28
	sts	FIFOptr+3,R29
UzDohnal:	sei
	rjmp	CountSMPL	;pocitat dalsi

	;nacist do RAM novy song
NewSong:	;zastavit cteni cudlu a play timer
	in	R16,timsk
	andi	R16,0b01111101
	out	timsk,R16
	;ukazatele ve FIFO zasobniku
	ldi	R30,low(OutputFIFO+0)	
	ldi	R31,high(OutputFIFO+0)
	ldi	R28,low(FIFOptr)
	ldi	R29,high(FIFOptr)
	st	Y+,R30	;RD adresa ve FIFO
	st	Y+,R31
	ldi	R30,low(OutputFIFO)
	ldi	R31,high(OutputFIFO)
	st	Y+,R30	;WR adresa ve FIFO
	st	Y+,R31
	;vypnout vsechny efekty
	clr	R16
	sts	PortamentoStack,R16
	sts	PortamentoStack+1,R16
	sts	PortamentoStack+2,R16
	sts	PortamentoStack+3,R16	
	sts	PortamentoStack+4,R16
	sts	PortamentoStack+5,R16
	sts	PortamentoStack+6,R16
	sts	PortamentoStack+7,R16
	sts	VolSlideStack,R16
	sts	VolSlideStack+1,R16
	sts	VolSlideStack+2,R16
	sts	VolSlideStack+3,R16
	sts	VolSlideStack+4,R16
	sts	VolSlideStack+5,R16
	sts	VolSlideStack+6,R16
	sts	VolSlideStack+7,R16
	sts	ArpeggioStack,R16
	sts	ArpeggioStack+7,R16
	sts	ArpeggioStack+14,R16
	sts	ArpeggioStack+21,R16

	;konstanty pro speed
	ldi	R16,low(333)
	sts	PatIncSpeed,R16
	ldi	R16,high(333)
	sts	PatIncSpeed+1,R16
	ldi	R16,low(334)
	sts	PatIncSpeed+2,R16
	ldi	R16,high(334)
	sts	PatIncSpeed+3,R16
	;konstanty pro delitele
	ldi	R16,7
	sts	PatIncSpeed+5,R16	;/8 samplu
	ldi	R16,0
	sts	PatIncSpeed+6,R16	;/8/8 samplu
	ldi	R16,0
	sts	PatIncSpeed+7,R16	;pro bargrafy
	ldi	R16,0
	sts	PatIncSpeed+8,R16	;pro arpeggio
	ldi	R16,0
	sts	PatIncSpeed+9,R16	;pro portamento
	ldi	R16,125
	sts	PatIncSpeed+4,R16	;tempo 125
	ldi	R16,6
	sts	SongSpeed,R16	;speed 6
	
	lds	R16,BitVars
	andi	R16,0b11000000	;nulovat vse mimo zdroj dat
	sts	BitVars,R16
	
	;vyber jestli hrat z RAM nebo ext. pameti
	bst	R16,6
	brtc	EPROMload
	rcall	USARTload
	rjmp	NeEPROMload
EPROMload:	rcall	LoadStartAd
	;napsat nazev songu na LCD
NeEPROMload:	ldi	R16,0b11111111
	out	ddrc,R16
	clr	R0
	clr	R1
	clr	R2
	;
	cbi	portb,1
	ldi	R16,0b10000000
	rcall	ByteToLCD
	sbi	portb,1
	ldi	R20,20	;20 znaku nazvu na zacxatku souboru
PisNazev:	ldi	R16,0b00000000
	out	ddrc,R16
	rcall	LoadData
	cpi	R16,0
	brne	NeKonecName
	ldi	R16,' '
NeKonecName:	ldi	R17,0b11111111
	out	ddrc,R17
	out	udr,R16	;odeslat nazev songu pres USART terminalu
	rcall	ByteToLCD
	rcall	ByteToLCDst	;zpozdeni navic
	inc	R0
	dec	R20
	brne	PisNazev
	;zalomit radek na terminalu
	ldi	R16,10
	out	udr,R16
	rcall	ByteToLCDst
	;
	ldi	R16,0b00000000
	out	ddrc,R16
	;nacist poradi listu + zjistit cilo nejvyssiho	
	rcall	LoadPatternList
	;nacist info o vzorcich
	rcall	LoadSmplList
	;nastavit list
	rcall	SetPatternPTR
	;vymazat FIFO
	rcall	ClearPlayDS
	
	;povolit cteni tlacitek a play timer 0
	ldi	R16,0b10000010
	out	tifr,R16
	in	R16,timsk
	ori	R16,0b10000010
	out	timsk,R16

	sei
	ret

	;bargrafy
WriteBarGraf:	;blokovat tlacitka
	cli
	in	R16,timsk
	andi	R16,0b01111111
	out	timsk,R16
	sei
	;
	ldi	R16,0b11111111
	out	ddrc,R16	
	sbi	portb,1
	ldi	R30,low(BarGraf)
	ldi	R31,high(BarGraf)
	ldi	R20,4	;4 kanaly
DalsiBarG:	ld	R17,Z+
	subi	R17,128
	swap	R17
	andi	R17,0b00000111
	mov	R16,R17
	rcall	ByteToLCD
	dec	R20
	brne	DalsiBarG
	;mix levy a pravy
	ldi	R16,' '
	rcall	ByteToLCD
	lds	R16,BarGraf
	subi	R16,128
	lds	R17,BarGraf+3
	subi	R17,128
	add	R16,R17
	swap	R16
	lsr	R16
	andi	R16,0b00000111
	rcall	ByteToLCD
	lds	R16,BarGraf+1
	subi	R16,128
	lds	R17,BarGraf+2
	subi	R17,128
	add	R16,R17
	swap	R16
	lsr	R16
	andi	R16,0b00000111
	rcall	ByteToLCD
	;fall speed - pomale klesani sloupcu :-)
	ldi	R30,low(BarGraf)
	ldi	R31,high(BarGraf)
	ldi	R20,4
NextChanBar1:	ld	R16,Z
	subi	R16,4	;fall speed
	cpi	R16,128
	brcc	NextChanBar
	ldi	R16,128
NextChanBar:	st	Z+,R16
	dec	R20
	brne	NextChanBar1
	cbi	portb,1
	ldi	R16,0b11001101
	rcall	ByteToLCD
	ldi	R16,0b00000000
	out	ddrc,R16
	;zapnout tlacitka
	cli
	in	R16,timsk
	ori	R16,0b10000000
	out	timsk,R16
	sei
	ret
	
	;vypis infa o perhravani na LD
LCDwriteStatus:	;blokovat tlacitka
	cli
	in	R16,timsk
	andi	R16,0b01111111
	out	timsk,R16
	sei
	;
	ldi	R16,0b11111111
	out	ddrc,R16
	;
	cbi	portb,1
	ldi	R16,0b11000000
	rcall	ByteToLCD
	sbi	portb,1
	;vypis cisla radku / cisla listu / poctu listu
	lds	R16,PatternPos
	ldi	R18,64
	sub	R18,R16
	rcall	bin2BCD8
	mov	R16,R17
	rcall	ByteToLCD
	mov	R16,R18
	rcall	ByteToLCD
	ldi	R16,'/'
	rcall	ByteToLCD
	lds	R18,PatternPTR
	inc	R18
	rcall	bin2BCD8
	rcall	ByteToLCD
	mov	R16,R17
	rcall	ByteToLCD
	mov	R16,R18
	rcall	ByteToLCD
	ldi	R16,'/'
	rcall	ByteToLCD	
	lds	R18,PatternN
	dec	R18
	rcall	bin2BCD8
	rcall	ByteToLCD
	mov	R16,R17
	rcall	ByteToLCD
	mov	R16,R18
	rcall	ByteToLCD
	;
	cbi	portb,1
	ldi	R16,0b11001101
	rcall	ByteToLCD
	;
	ldi	R16,0b00000000
	out	ddrc,R16
	;zapnout tlacitka
	cli
	in	R16,timsk
	ori	R16,0b10000000
	out	timsk,R16
	sei
	ret
	
	;prevod z binarniho do dekadickeho tvaru pro 8bit cislo
bin2bcd8:	clr	R17
	clr	R16
bBCD8_1:	subi	R18,10
	brcs	bBCD8_2
	inc	R17
	subi	R17,10
	brcs	bBCD8_3
	inc	R16
	rjmp	bBCD8_1
bBCD8_3:	subi	R17,-10
	rjmp	bBCD8_1
bBCD8_2:	subi	R18,-10
	;na ASCII
	subi	R16,-48
	subi	R17,-48
	subi	R18,-48
	;nahradi nuly na zacatku mezerou	
	cpi	R16,48
	brne	DeNulovano
	ldi	R16,' '
	cpi	R17,48
	brne	DeNulovano
	ldi	R17,' '
DeNulovano:	ret

	;nacteni songu pres USART
USARTload:	rcall	LoadDataText	;napis nacitam data
	;nastavit adresu RAM na zacatek
	clr	R3
	clr	R4
	clr	R5
	clr	R14
	inc	R14
	clr	R15
	in	R16,udr	;vyprazdnit prijimaci registr (jen pro jistotu)
	in	R16,udr
	in	R16,udr
	in	R16,udr	
	;pripravit RAM pro zapis
	sbi	portd,4
	ldi	R16,0b11111111
	out	ddrc,R16
	;start timeout CTR
	ldi	R16,low(35000)	;asi 2s timeout
	ldi	R17,high(35000)
	out	ocr1ah,R17
	out	ocr1al,R16
	clr	R0
	out	tcnt1h,R0
	out	tcnt1l,R0

	ldi	R16,0b00010000
	out	timsk,R16
	
	ldi	R16,0b11111111
	out	tifr,R16
	sei
	clr	R25
	
	;prijimana data zapisovat a inkrementovat adresu
RxByteD:	cpi	R25,255
	breq	RxComp
	sbis	ucsra,rxc
	rjmp	RxByteD
	in	R16,udr
	out	portc,R16	;data na port
	out	porta,R5
	cbi	portd,5
	sbi	portd,5	
	out	porta,R4
	cbi	portd,6
	sbi	portd,6
	out	porta,R3
	;
	add	R3,R14
	adc	R4,R15
	adc	R5,R15
	ldi	R16,8	;pri prekroceni 524288B dal nezapisovat
	cp	R5,R16
	brcc	PlnaRAM
	;
	cbi	portb,3
	nop
	sbi	portb,3
	;
PlnaRAM:	clr	R0
	out	tcnt1h,R0
	out	tcnt1l,R0
	rjmp	RxByteD
	;stop timeout CTR
RxComp:	cli
	ldi	R16,0b00000000
	out	timsk,R16
	rjmp	LoadCom	;pokracovat v nacteni songu (pokracuje nize)
	
	;nacteni dat z externi pameti do RAM
	;nacteni pocatecni adresy v ext. pameti
LoadStartAd:	rcall	LoadDataText
	sbi	portd,4
	cbi	portd,7	;data z ext. pameti
	ldi	R30,low(Songs*2)
	ldi	R31,high(Songs*2)
	lds	R16,SongPTR
	lsl	R16
	lsl	R16
	clr	R17
	add	R30,R16
	adc	R31,R17
	lpm	R3,Z+
	lpm	R4,Z+
	lpm	R5,Z+
	lpm	R6,Z+	;pro sync.
	lpm	R6,Z+
	lpm	R7,Z+
	lpm	R8,Z+
	sub	R6,R3
	sbc	R7,R4
	sbc	R8,R5
	ldi	R16,1
	clr	R17
	add	R7,R16	;tady je pocet 256B bloku
	adc	R8,R17
	ldi	R16,12	;pro LCD ukazatel
	mul	R7,R16
	mov	R25,R1
	mul	R8,R16
	add	R25,R0
	mov	R17,R7
	mov	R18,R8
	mov	R24,R25	;konst. pro LCD ukazatel
	;kopirovat do RAM z EPROM
	mov	R0,R3
	mov	R1,R4
	mov	R2,R5
	clr	R3
	clr	R4
	clr	R5	;zacatek RAM
	clr	R14	;1
	clr	R15
	inc	R14
	;kopiruje se po blocich 256B
KopirujSong:	ldi	R16,0b00000000
	out	ddrc,R16
	sbi	portd,4
	cbi	portd,7
	ldi	R30,low(OutputFIFO)
	ldi	R31,high(OutputFIFO)
	ldi	R20,0	;256B blok
CistBlok:	out	porta,R2
	cbi	portd,5
	sbi	portd,5
	out	porta,R1
	cbi	portd,6
	sbi	portd,6
	out	porta,R0
	;
	add	R0,R14
	adc	R1,R15
	adc	R2,R15
	nop
	nop
	;
	in	R16,pinc
	st	Z+,R16
	dec	R20
	brne	CistBlok
	;zapis bloku
	sbi	portd,7
	ldi	R16,0b11111111
	out	ddrc,R16
	ldi	R30,low(OutputFIFO)
	ldi	R31,high(OutputFIFO)
	ldi	R20,0	;256B blok
PisBlok:	ld	R16,Z+
	out	portc,R16	;data na port
	out	porta,R5
	cbi	portd,5
	sbi	portd,5	
	out	porta,R4
	cbi	portd,6
	sbi	portd,6
	out	porta,R3
	;
	add	R3,R14
	adc	R4,R15
	adc	R5,R15
	nop
	nop
	;
	cbi	portb,3
	sbi	portb,3
	;
	dec	R20
	brne	PisBlok
	dec	R25
	brne	NeLCDldinc
	mov	R25,R24
	sbi	portb,1
	ldi	R16,7
	rcall	ByteToLCD
NeLCDldInc:	sub	R17,R14
	sbc	R18,R15
	brne	KopirujSong
LoadCom:	rcall	LoadDataText
	;vycistit zasobnik
	ldi	R16,low(FIFOsize)
	ldi	R17,high(FIFOsize)
	ldi	R30,low(OutputFIFO)
	ldi	R31,high(OutputFIFO)
	clr	R0
MazFIFO:	st	Z+,R0
	subi	R16,1
	sbci	R17,0
	brne	MazFIFO
	;
	ldi	R16,0b00000000
	out	ddrc,R16
	sbi	portd,7
	cbi	portd,4	;RAM selsect
	clr	R0
	clr	R1
	clr	R2
	;zjiste o jaky typ MODu jde a nacteni adres, kde zacinaji listy a poradi listu
	ldi	R17,low(600)
	ldi	R18,high(600)
	sts	PatternStart,R17
	sts	PatternStart+1,R18
	ldi	R17,low(470)
	ldi	R18,high(470)
	sts	PatList,R17
	sts	PatList+1,R18
	
	ldi	R16,low(1080)
	ldi	R17,high(1080)
	clr	R18
	add	R0,R16
	adc	R1,R17
	adc	R2,R18
	ldi	R30,low(FileTypeT*2)
	ldi	R31,high(FileTypeT*2)
	ser	R18
	ser	R19
	ldi	R20,4	
	
DalsiZnakTyp:	rcall	LoadData
	lpm	R17,Z+
	cp	R16,R17
	breq	NeJinejMozna
	clr	R18
NeJinejMozna:	lpm	R17,Z+
	cp	R16,R17
	breq	NeJinejMozna1
	clr	R19
NeJinejMozna1:	ldi	R16,1
	clr	R17
	add	R0,R16
	adc	R1,R17
	adc	R2,R17
	dec	R20
	brne	DalsiZnakTyp
	or	R18,R19
	cpi	R18,0
	breq	MinSMPLs
	ldi	R17,low(1084)
	ldi	R18,high(1084)
	sts	PatternStart,R17
	sts	PatternStart+1,R18
	ldi	R17,low(950)
	ldi	R18,high(950)
	sts	PatList,R17
	sts	PatList+1,R18
MinSmpls:	ret

FileTypeT:	.db	'M','F'
	.db	'.','L'
	.db	'K','T'
	.db	'.','4'

	;vypise text "Nacitam data ..."
LoadDataText:	ldi	R16,0b11111111
	out	ddrc,R16
	cbi	portb,1
	ldi	R16,0b10000000
	rcall	ByteToLCD
	ldi	R30,low(NacitDT*2)
	ldi	R31,high(NacitDT*2)
	sbi	portb,1
	ldi	R20,20
PisLDtext1:	lpm	R16,Z+
	rcall	ByteToLCD
	dec	R20
	brne	PisLDtext1
	cbi	portb,1
	ldi	R16,0b11000000
	rcall	ByteToLCD
	sbi	portb,1
	ldi	R30,low(BaudRateDT*2)
	ldi	R31,high(BaudRateDT*2)
	sbi	portb,1
	ldi	R20,20
PisLDtext11:	lpm	R16,Z+
	rcall	ByteToLCD
	dec	R20
	brne	PisLDtext11
	cbi	portb,1
	ldi	R16,0b11000000
	rcall	ByteToLCD
	ldi	R16,0b00000000
	out	ddrc,R16
	ret
NacitDT:	.db	"Nacitam data ...    "
BaudRateDT:	.db	"                    "

	;nastaveni listu a radku	
SetPatternPTR:	ldi	R16,1
	sts	PatternPos,R16
	ldi	R16,255
	sts	PatternPTR,R16
	ret
	
LoadSmplList:	;nejdriv adresa 1. vzorku do R5:R3
	lds	R4,HighestPatN
	inc	R4
	clr	R5
	clr	R3
	lsl	R4
	rol	R5
	lsl	R4
	rol	R5
	lds	R16,PatternStart
	lds	R17,PatternStart+1
	clr	R18
	add	R3,R16
	adc	R4,R17
	adc	R5,R18
	;ted uz zapis zacatku, koncu a smycek
	ldi	R16,42
	mov	R0,R16
	clr	R1
	clr	R2
	ldi	R30,low(SmplsAdress)
	ldi	R31,high(SmplsAdress)
	ldi	R25,0
	
	;zacatek vzorku
DalsiSmplL:	;stop adresa
	rcall	LoadData
	mov	R7,R16
	ldi	R16,1
	rcall	AddR16Adr
	rcall	LoadData
	mov	R6,R16
	clr	R8
	lsl	R6
	rol	R7
	rol	R8
	add	R6,R3
	adc	R7,R4
	adc	R8,R5
	push	R6
	push	R7
	push	R8
	;hlasitost
	ldi	R16,2
	rcall	AddR16Adr
	rcall	LoadData
	lsl	R16
	lsl	R16
	subi	R16,1
	mov	R12,R16
	;zacatek smycky
	ldi	R16,1
	rcall	AddR16Adr
	rcall	LoadData
	mov	R10,R16
	ldi	R16,1
	rcall	AddR16Adr
	rcall	LoadData
	mov	R9,R16	
	clr	R11
	lsl	R9
	rol	R10
	rol	R11
	add	R9,R3
	adc	R10,R4
	adc	R11,R5
	;delka smycky
	ldi	R16,1
	rcall	AddR16Adr
	rcall	LoadData
	mov	R14,R16
	ldi	R16,1
	rcall	AddR16Adr
	rcall	LoadData
	mov	R13,R16
	clr	R16
	ldi	R17,2
	cp	R13,R17
	cpc	R14,R16
	brcs	NeLoop1
	;smycka aktivni
	clr	R15
	lsl	R13
	rol	R14
	rol	R15
	add	R13,R9
	adc	R14,R10
	adc	R15,R11
	mov	R6,R13
	mov	R7,R14
	mov	R8,R15
	rjmp	Loop1
	;skutecna stop adresa
NeLoop1:	ldi	R16,0b10000000
	mov	R11,R16
Loop1:	;odecist 1 od konce dat
	ldi	R17,1
	clr	R17
	sub	R6,R16
	sbc	R7,R17
	sbc	R8,R17
	;uz zapis
	st	Z+,R12	;hlasitost
	st	Z+,R3	;start adresa
	st	Z+,R4
	st	Z+,R5
	st	Z+,R6	;stop adresa
	st	Z+,R7
	st	Z+,R8
	st	Z+,R9	;repeat adresa
	st	Z+,R10
	st	Z+,R11
	;ted adresa dalsiho vzorku do R5:R3 a dalsi vzorek v pameti
	pop	R5
	pop	R4
	pop	R3
	ldi	R16,1
	ldi	R17,0
	sub	R3,R16	;korekce, kvuli nesmyslnemu umisteni samplu v souboru 
	sbc	R4,R17
	sbc	R5,R17
ZadnejSMPL1:	ldi	R16,23
	ldi	R17,0
	add	R0,R16
	adc	R1,R17
	adc	R2,R17
	
	inc	R25
	cpi	R25,31
	breq	NeDalsiSMPLl
	rjmp	DalsiSMPLl
NeDalsiSMPLl:	ret
	;pricist R16 k adrese dane R0:R2
AddR16Adr:	clr	R17
	add	R0,R16
	adc	R1,R17
	adc	R2,R17
	ret
	;vycisti zasobnik prehravanych dat
ClearPlayDS:	ldi	R30,low(PlayDataS)
	ldi	R31,high(PlayDataS)
	ldi	R20,76
	clr	R0
CPDS:	st	Z+,R0
	dec	R20
	brne	CPDS
	ret
	
	;nacte poradi listu do zasobniku, zjisti cilo nejvyssiho
LoadPatternList:	ldi	R30,low(PatternList)
	ldi	R31,high(PatternList)
	lds	R0,PatList
	lds	R1,PatList+1
	clr	R2
	rcall	LoadData
	inc	R16
	sts	PatternN,R16
	ldi	R16,2
	ldi	R17,0
	add	R0,R16
	adc	R1,R17
	adc	R2,R17
	ldi	R20,127	;pocet listu
	clr	R21	;nejvyssi cislo listu
PatternLoad1:	rcall	LoadData
	st	Z+,R16
	cp	R16,R21
	brlo	PatLower
	mov	R21,R16
PatLower:	ldi	R16,1
	add	R0,R16
	ldi	R16,0
	adc	R1,R16
	adc	R2,R16
	dec	R20
	cpi	R20,0
	brne	PatternLoad1
	;zapis cislo nejvyssiho listu
	sts	HighestPatN,R21
	ret
	;nacte byte z adresy R0:R2 do R16
LoadData:	out	porta,R2
	cbi	portd,5
	sbi	portd,5
	out	porta,R1
	cbi	portd,6
	sbi	portd,6
	out	porta,R0
	nop
	nop
	nop
	in	R16,pinc
	ret
	
	;tady se ctou noty a nastavuji vsechny konstanty pro efekty a prehravani
	;nejdriv cislo radku v listu, kdyz 0, tak dalsi list not
Takt:	lds	R16,PatternPos
	dec	R16
	sts	PatternPos,R16
	brne	DekodujList
	ldi	R16,64	;reset pocitadla radku
	sts	PatternPos,R16
	;nacist dalsi list not podle pole poradi listu
	ldi	R28,low(PatternList)
	ldi	R29,high(PatternList)
	lds	R0,PatternPTR
	lds	R16,BitVars
	bst	R16,3
	brts	IncListBut	;nehrat dalsi list, pokud je list nastaven tlacitky
	inc	R0
IncListBut:	andi	R16,0b11110111
	sts	BitVars,R16
	clr	R1
	add	R28,R0
	adc	R29,R1
	sts	PatternPTR,R0
	lds	R1,PatternN
	dec	R1
	cp	R0,R1
	brne	HrajDal	;pokud je posledni list, tak pokyn k prehravani dalsiho songu
	lds	R16,BitVars
	ori	R16,0b00000001	;prehrat dalsi song (nebo znovu z RAM)
	sts	BitVars,R16
	bst	R16,6
	brts	HrajDal	;kdyz se hraje z RAM, tak ne dalsi song
	lds	R16,SongPTR
	inc	R16
	cpi	R16,SongN
	sts	SongPTR,R16
	brne	HrajDal
	clr	R16
	sts	SongPTR,R16
HrajDal:	;vypocitat a nastavit adresu prvniho radku v dalsim liste
	clr	R0
	ld	R1,Y+
	clr	R2
	lsl	R1
	rol	R2
	lsl	R1
	rol	R2
	lds	R16,PatternStart
	lds	R17,PatternStart+1
	clr	R18
	add	R0,R16
	adc	R1,R17
	adc	R2,R18
	sts	LinePTR,R0
	sts	LinePTR+1,R1
	sts	LinePTR+2,R2
	;tady uz nastaveni nekterych promennych, pro vlastni cteni radku
DekodujList:	ldi	R28,low(PlayDataS)
	ldi	R29,high(PlayDataS)
	ldi	R16,0
	;tady zacina smycka pro cteni not pro kazdy ze 4 kanalu
	clr	R20	;pro 4 kanaly
	;nejprve precteni 4 bytu jedne "noty"
DalsiKanal:	lds	R0,LinePTR
	lds	R1,LinePTR+1
	lds	R2,LinePTR+2
	rcall	LoadData
	mov	R24,R16
	andi	R24,0b11110000	;high cislo vzorku
	andi	R16,0b00000011
	mov	R11,R16	;high ton
	ldi	R16,1
	ldi	R17,0
	add	R0,R16
	adc	R1,R17
	adc	R2,R17
	rcall	LoadData
	mov	R10,R16	;low ton
	ldi	R16,1
	ldi	R17,0
	add	R0,R16
	adc	R1,R17
	adc	R2,R17
	rcall	LoadData
	mov	R22,R16
	andi	R22,0b00001111
	swap	R16
	andi	R16,0b00001111
	or	R24,R16	;low cilso vzorku
	ldi	R16,1
	ldi	R17,0
	add	R0,R16
	adc	R1,R17
	adc	R2,R17
	rcall	LoadData
	mov	R21,R16	;efekt
	ldi	R16,1
	ldi	R17,0
	add	R0,R16
	adc	R1,R17
	adc	R2,R17
	sts	LinePTR,R0
	sts	LinePTR+1,R1
	sts	LinePTR+2,R2
	;zpracovani hlavnich dat (novy vzorek, ton, hlasitost)
	clt
	clr	R23
	cpi	R24,0
	brne	NeZadnejVzorek
	clr	R16
	cp	R10,R16
	cpc	R11,R16
	breq	NovyTon
	set
	dec	R24
	rjmp	NeNovyTon
NovyTon:	adiw	R28,19
	rjmp	ZadnejVzorek
NeZadnejVzorek:	dec	R24
	;nastaveni tonu samplu
	clr	R16
	cp	R10,R16
	cpc	R11,R16
	brne	NeNovyTon
	adiw	R28,6	;kdyz neni ton ale jen cislo samplu
	ser	R23
	ld	R16,Y
	cp	R16,R24
	breq	NovyTonOk
	st	Y+,R24
	clr	R0	;kdyz je jen cislo samplu bez tonu, ale je jiny nez minule
	rjmp	JenNsmpluJiny	;hlasitost na 0
	;
NeNovyTon:	ldi	R16,35	;nacteni cisla tonu pro Arpeggio
	mul	R11,R16
	mov	R2,R0
	mul	R10,R16
	add	R1,R2
	ldi	R16,15
	sub	R1,R16
	clr	R0
	ldi	R30,low(freqT*2)
	ldi	R31,high(freqT*2)
	add	R30,R1
	adc	R31,R0
	lpm	R0,Z+
	st	Y+,R0	;save do play zasobniku
	;vypocet presne konstanty frekvence z nesmyslnych cisel v souboru :-)
	ldi	R16,low(41088)	;41088/T = freknece prehravani
	ldi	R17,high(41088)
	movw	R18,R10	;nactena perioda T
	rcall	div16u	;ano deleni a pekne dlouhe ...
	;
	st	Y+,R16	;frekvence zalozni (obcas je potreba frekveci obnovit)
	st	Y+,R17
	;
	clr	R1
	st	Y+,R1	;pomocny byte pro frekvenci
	cpi	R22,3
	brne	TonePortLF	;pri tone-portamneto nemenit hlavni frekvenci
	cpi	R21,100	;kdyz je portamento speed moc velka, tak skokem
	brcs	NeTonePortLF
	clr	R22	;a neprovadet portamento
	clr	R21
	rjmp	TonePortLF
NeTonePortLF:	adiw	R28,2
	rjmp	NovyTonOk
TonePortLF:	st	Y+,R16	;frekvence hlavni
	st	Y+,R17
	;hlasitost, start, stop a repeat pozice
NovyTonOk:	cpi	R24,255
	brne	MinulySMPLnewf
	ld	R24,Y
MinulySMPLnewf:	st	Y+,R24
	ldi	R16,10
	mul	R16,R24
	ldi	R30,low(SmplsAdress)
	ldi	R31,high(SmplsAdress)
	add	R30,R0
	adc	R31,R1
	ld	R0,Z+
JenNsmpluJiny:	clr	R2
	st	Y+,R2	;pomocna hlasitost
	brtc	NeMenitVol
	ld	R0,Y
NeMenitVol:	st	Y+,R0	;hlavni hlasitost
	;
	cpi	R22,6
	breq	TportNeChSMPLP	;kdyz efekt 6. tak neobnovovat adresu vzorku
	cpi	R22,5
	breq	TportNeChSMPLP	;kdyz efekt 5. tak neobnovovat adresu vzorku
	cpi	R22,3
	breq	TportNeChSMPLP	;kdyz efekt 3. tak neobnovovat adresu vzorku
	cpi	R23,0
	breq	NastPosSMPL	;kdyz je jen cilso samplu bez tonu
TportNeChSMPLP:	clr	R23	;tak nemenit adresy samplu
	adiw	R28,10
	rjmp	ZadnejVzorek
NastPosSMPL:	clr	R0
	st	Y+,R0
	ldi	R16,9	;9 bytu
CopySdata:	ld	R0,Z+
	st	Y+,R0
	dec	R16
	brne	CopySdata
ZadnejVzorek:	;tady se uz detekuji a nastavuji jednotlive efekty
	;C - set volume
	cpi	R22,0xC
	brne	NeSetVolume
	cpi	R21,0
	breq	SetTicho
	cpi	R21,40
	brlo	NedelalToAmater
	;nekteri autori pisou az 64, misto 40 - nevedi, ze je to v hexa :-)
	ldi	R21,0x40 
NedelalToAmater:	lsl	R21
	lsl	R21
	subi	R21,1
SetTicho:	sbiw	R28,12
	clr	R0
	st	Y+,R0
	st	Y,R21
	adiw	R28,11
	;5 - volume slide + pokracovat v tone-portamento
NeSetVolume:	cpi	R22,5
	breq	VolSlideO
	;6 - volume slide + pokracovat ve vibratu
	cpi	R22,6
	breq	VolSlideO
	;A - volume slide
	cpi	R22,0xA
	brne	NeVolumeSlide
VolSlideO:	cpi	R21,0
	breq	MoznaSetSpeed
	ldi	R30,low(VolSlideStack)
	ldi	R31,high(VolSlideStack)
	mov	R16,R20
	lsl	R16
	clr	R17
	add	R30,R16
	adc	R31,R17
	;
	ldi	R16,130
	mov	R17,R21
	andi	R17,0b00001111
	cpi	R17,0
	breq	VolSlideUp
	;pro slide down
	mul	R17,R16
	rjmp	VolSlideOk
VolSlideUp:	mov	R17,R21
	swap	R17
	andi	R17,0b00001111
	cpi	R17,0
	breq	VolSlideOk
	mul	R17,R16
	ldi	R16,0b10000000
	or	R1,R16
VolSlideOk:	st	Z+,R0
	st	Z+,R1
	rjmp	MoznaSetSpeed
	;vypnout volume slide
NeVolumeSlide:	ldi	R30,low(VolSlideStack)
	ldi	R31,high(VolSlideStack)
	mov	R16,R20
	lsl	R16
	clr	R17
	add	R30,R16
	adc	R31,R17
	ldi	R16,0
	st	Z+,R16
	st	Z+,R16
	;F - set speed/tempo
MoznaSetSpeed:	cpi	R22,0xF
	brne	NeSetSpeed
	cpi	R21,33
	mov	R16,R21
	brcc	SetTempo
	ldi	R30,low(SpeedTab*2)
	ldi	R31,high(SpeedTab*2)
	clr	R0
	sts	SongSpeed,R16
	lsl	R16
	add	R30,R16
	adc	R31,R0
	lpm	R16,Z+
	lpm	R17,Z+
	sts	PatIncSpeed+2,R16
	sts	PatIncSpeed+3,R17
	lds	R21,PatIncSpeed+4
SetTempo:	sts	PatIncSpeed+4,R21
	lds	R16,PatIncSpeed+2
	lds	R17,PatIncSpeed+3
	subi	R21,33
	ldi	R30,low(TempoKorekceT*2)
	ldi	R31,high(TempoKorekceT*2)
	clr	R0
	add	R30,R21
	adc	R31,R0
	lpm	R18,Z
	mul	R17,R18
	movw	R4,R0
	mul	R16,R18
	clr	R2
	add	R1,R4
	adc	R2,R5
	;delit 64
	lsl	R0
	rol	R1
	rol	R2
	lsl	R0
	rol	R1
	rol	R2
	sts	PatIncSpeed+2,R1
	sts	PatIncSpeed+3,R2
	;D - break pattern, jen zalamuje, neumi skocit na dany radek listu
NeSetSpeed:	cpi	R22,0xD
	brne	NeBreak
	ldi	R16,1
	sts	PatternPos,R16
	;9 - nastavi pocatecni pozici v samplu
NeBreak:	cpi	R22,9
	brne	NeSetPos
	clr	R3
	clr	R0
	clr	R16
	sbiw	R28,8	;navrat na pozici vzorku
	ld	R1,Y+
	ld	R2,Y+
	clr	R0
	add	R1,R21
	adc	R2,R16
	sbiw	R28,4	;navrat na pozici vzorku
	st	Y+,R0
	st	Y+,R0
	st	Y+,R1
	st	Y+,R2
	adiw	R28,6
	;1 - portamento up (plynule zvyseni tonu)
NeSetPos:	cpi	R22,1
	brne	NePortamentoUp
	rcall	LoadPortStackAd
	rcall	PortSpeedKor
	;	
	ldi	R16,0b00100000
	or	R1,R16
	st	X+,R0
	st	X+,R1
	rjmp	NePortUpOff
	;
NePortamentoUp:	rcall	LoadPortStackAd
	adiw	R26,1
	ld	R16,X
	bst	R16,6
	brts	NePortUpOff
	bst	R16,7
	brts	NePortUpOff
	clr	R16
	st	X+,R16
	;2 - portamento down (plynule snizeni tonu)
NePortUpOff:	cpi	R22,2
	brne	NePortDown
	rcall	LoadPortStackAd
	rcall	PortSpeedKor
	;	
	ldi	R16,0b10100000
	or	R1,R16
	st	X+,R0
	st	X+,R1
	rjmp	NePortDownOff
	;
NePortDown:	rcall	LoadPortStackAd
	adiw	R26,1
	ld	R16,X
	bst	R16,6
	brts	NePortDownOff
	bst	R16,7
	brtc	NePortDownOff
	clr	R16
	st	X+,R16
	;3 - tone-portamento plynuly prechod na jinou notu
NePortDownOff:	cpi	R22,3
	brne	NeTonePort
	rcall	LoadPortStackAd
	sbiw	R28,18
	ld	R16,Y+
	ld	R17,Y+
	adiw	R28,1
	ld	R18,Y+
	ld	R19,Y+
	adiw	R28,13
	cp	R16,R18
	cpc	R17,R19
	breq	NeTonePortNotEq
	rjmp	TonePortNotEq
	;nemenit
NeTonePortNotEq:	ldi	R19,0b00000000
	rjmp	TonePortCom
TonePortNotEq:	brcs	TonePortD
	;zvysovani
	ldi	R19,0b01100000
	rjmp	TonePortCom
	;snizovani
TonePortD:	ldi	R19,0b11100000
TonePortCom:	rcall	PortSpeedKor
	cpi	R21,0
	brne	NeTonePortNK	;kdyz uz ma jen pokracovat R21=0
	ld	R0,X+
	ld	R1,X+
	sbiw	R26,2
NeTonePortNK:	or	R1,R19
	st	X+,R0
	st	X+,R1
	rjmp	NeTonePortOff
	;vypnout tone portamento
NeTonePort:	cpi	R22,5	;pro efekt 5
	breq	NeTonePortOff
	cpi	R22,6	;a pro efekt 6 nevypinat port
	breq	NeTonePortOff
	rcall	LoadPortStackAd
	adiw	R26,1
	ld	R16,X
	bst	R16,6
	brtc	NeTonePortOff
	andi	R16,0b00011111
	st	X+,R16
	;0 - Arpeggio (skokova zmena tonu mezi 3 tony) / nic, pac 0 ...
NeTonePortOff:	cpi	R22,0
	brne	NeArpeggio
	cpi	R21,0
	breq	NeArpeggio
	;cislo kanalu
	ldi	R26,low(ArpeggioStack)
	ldi	R27,high(ArpeggioStack)
	mov	R16,R20
	ldi	R17,7
	mul	R16,R17
	add	R26,R0
	adc	R27,R1
	;vypocitat frekvence
	ldi	R30,low(FreqNewT*2)
	ldi	R31,high(FreqNewT*2)
	sbiw	R28,19
	ld	R16,Y	;cislo zakladni frekvence
	adiw	R28,19
	lsl	R16
	clr	R17
	add	R30,R16
	adc	R31,R17
	;ktery ton hrat nejdriv
	ld	R16,X
	cpi	R16,0
	brne	UzJeAktivArp
	ldi	R16,1
UzJeAktivArp:	st	X+,R16
	;nacist konst. pro zakladni frekvenci
	lpm	R1,Z+
	lpm	R0,Z+
	st	X+,R0
	st	X+,R1	;zakladni zapsan
	sbiw	R30,2
	movw	R24,R30
	mov	R16,R21
	andi	R16,0b00001111	;vybrat prvni frekvenci
	lsl	R16
	clr	R17
	sub	R30,R16
	sbc	R31,R17
	lpm	R19,Z+
	lpm	R18,Z+	;nactena frekvence 1
	st	X+,R18
	st	X+,R19
	movw	R30,R24
	mov	R16,R21
	swap	R16
	andi	R16,0b00001111	;vybrat druhou frekvenci
	lsl	R16
	clr	R17
	sub	R30,R16
	sbc	R31,R17
	lpm	R19,Z+
	lpm	R18,Z+	;nactena frekvence 2
	st	X+,R18
	st	X+,R19
	rjmp	NeDeArp1
	;toto je ukonceni arpeggia - frekvence se nastavi na puvodni (zalozni)
NeArpeggio:	;cislo kanalu
	ldi	R26,low(ArpeggioStack)
	ldi	R27,high(ArpeggioStack)
	mov	R16,R20
	ldi	R17,7
	mul	R16,R17
	add	R26,R0
	adc	R27,R1
	ld	R16,X
	cpi	R16,0	;bylo aktivni?
	breq	NeDeArp1
	clr	R16
	st	X,R16	;vypnout arpeggio
	;vypocitat frekvence
	ldi	R30,low(FreqNewT*2)
	ldi	R31,high(FreqNewT*2)
	sbiw	R28,18
	ld	R16,Y+	;cislo zakladni frekvence
	ld	R17,Y+
	clr	R18
	st	Y+,R18
	st	Y+,R16
	st	Y+,R17
	adiw	R28,13
NeDeArp1:	;efekty Ex
	cpi	R22,0xE
	breq	EfektyE
	rjmp	NeEfektyE
EfektyE:	mov	R22,R21
	andi	R22,0b11110000
	swap	R22
	andi	R21,0b00001111
	;EA - jemne volume up
	cpi	R22,0xA
	brne	NeFineVolUP
	sbiw	R28,12
	clr	R0
	st	Y+,R0
	ld	R16,Y
	lsl	R21
	lsl	R21
	add	R16,R21	;pricist konstantu
	brcc	NeMaxVolFSU
	ldi	R16,255
NeMaxVolFSU:	st	Y,R16
	adiw	R28,11
	;EB - jemne volume down 
NeFineVolUp:	cpi	R22,0xB
	brne	NeFineVolDown
	sbiw	R28,12
	clr	R0
	st	Y+,R0
	ld	R16,Y
	lsl	R21
	lsl	R21
	sub	R16,R21	;odecist konstantu
	brcc	NeMinVolFSD
	ldi	R16,0
NeMinVolFSD:	st	Y,R16
	adiw	R28,11
NeFineVolDown:	;E1 - jemne portamneto up
	cpi	R22,1
	brne	NeFinePortUp
	sbiw	R28,15
	ld	R16,Y+
	ld	R17,Y+
	sbiw	R28,2
	clr	R18
	add	R16,R21
	adc	R17,R18
	st	Y+,R16
	st	Y+,R17
	adiw	R28,13
NeFinePortUp:	;E2 - jemne portamneto down
	cpi	R22,2
	brne	NeFinePortDown
	sbiw	R28,15
	ld	R16,Y+
	ld	R17,Y+
	sbiw	R28,2
	sub	R16,R21
	sbci	R17,0
	st	Y+,R16
	st	Y+,R17
	adiw	R28,13
NeFinePortDown:	;dalsi kanal
NeEfektyE:	inc	R20
	cpi	R20,4
	breq	NeDalsiKanal
	rjmp	DalsiKanal
NeDalsiKanal:	;uz vypocteny vsechny 4 kanaly
	;zobrazit status na LCD
	rcall	LCDwriteStatus
	ret
	
	;koeficienty pro portamneto pro ruzne rychlosti
	;     konstanty	 speed
PortamentoT:	.db	0,1	;0,1
	.db	2,3	;2,3
	.db	4,4	;4,5
	.db	4,4	;6,7
	.db	4,4	;8,9
	.db	4,4	;10,11
	.db	4,4	;12,13
	.db	4,4	;14,15
	
	;tabulka konstant pro prehravaci rychlosti
SpeedTab:	.dw	52	;0 - ?????
	.dw	52	;1 - 51.18
	.dw	106	;2 - 25.43
	.dw	162	;3 - 16.83
	.dw	218	;4 - 12.59
	.dw	272	;5 - 10.07
	.dw	323	;6 - 8.47
	.dw	384	;7 - 7.2
	.dw	435	;8 - 6.35
	.dw	492	;9 - 5.63
	.dw	551	;A - 5.03
	.dw	601	;B - 4.61
	.dw	660	;C - 4.2
	.dw	710	;D - 3.91
	.dw	768	;E - 3.61
	.dw	828	;F - 3.35
	.dw	871	;10 - 3.2
	.dw	915	;11 - 3.05
	.dw	976	;12 - 2.85
	.dw	1038	;13 - 2.69
	.dw	1096	;14 - 2.55
	.dw	1160	;15 - 2.4
	.dw	1227	;16 - 2.27
	.dw	1290	;17 - 2.16
	.dw	1328	;18 - 2.1
	.dw	1395	;19 - 2
	.dw	1447	;1A - 1.93
	.dw	1501	;1B - 1.86
	.dw	1547	;1C - 1.8
	.dw	1600	;1D - 1.74
	.dw	1674	;1E - 1.66
	.dw	1700	;1F - 1.64
	.dw	1783	;20 - 1.62

;SpeedTab:	.dw	9	;0 - 
;	.dw	55	;1 - 51.18
;	.dw	110	;2 - 25.43
;	.dw	166	;3 - 16.83
;	.dw	222	;4 - 12.59
;	.dw	277	;5 - 10.07
;	.dw	329	;6 - 8.47
;	.dw	388	;7 - 7.2
;	.dw	439	;8 - 6.35
;	.dw	496	;9 - 5.63
;	.dw	555	;A - 5.03
;	.dw	605	;B - 4.61
;	.dw	664	;C - 4.2
;	.dw	714	;D - 3.91
;	.dw	773	;E - 3.61
;	.dw	833	;F - 3.35

	;prevodni tabulka pro nastaveni tempa
TempoKorekceT:	.db	248,241,234,228,221,216,210,205
	.db	200,195,191,186,182,178,174,171
	.db	167,164,161,158,155,152,149,146
	.db	144,141,139,137,134,132,130,128
	.db	126,124,122,120,119,117,115,114
	.db	112,111,109,108,106,105,104,102
	.db	101,100,99,98,96,95,94,93
	.db	92,91,90,89,88,87,86,85
	.db	84,84,83,82,81,80,80,79
	.db	78,77,77,76,75,74,74,73
	.db	72,72,71,71,70,69,69,68
	.db	68,67,67,66,66,65,65,64
	.db	64,63,63,62,62,61,61,60
	.db	60,59,59,59,58,58,57,57
	.db	56,56,56,55,55,55,54,54
	.db	54,53,53,53,52,52,52,51
	.db	51,51,50,50,50,49,49,49
	.db	48,48,48,48,47,47,47,47
	.db	46,46,46,46,45,45,45,45
	.db	44,44,44,44,43,43,43,43
	.db	42,42,42,42,42,41,41,41
	.db	41,41,40,40,40,40,40,39
	.db	39,39,39,39,38,38,38,38
	.db	38,38,37,37,37,37,37,37
	.db	36,36,36,36,36,36,35,35
	.db	35,35,35,35,35,34,34,34
	.db	34,34,34,34,33,33,33,33
	.db	33,33,33,33,32,32,32,32
	
	;nacte adresu portamento zasobniku pro R20 kanal
LoadPortStackAd:	ldi	R26,low(PortamentoStack)
	ldi	R27,high(PortamentoStack)
	mov	R18,R20
	lsl	R18
	clr	R16
	add	R26,R18
	adc	R27,R16
	ret
	;korekce na speed pro portamento
PortSpeedKor:	ldi	R30,low(PortamentoT*2)
	ldi	R31,high(PortamentoT*2)
	lds	R16,SongSpeed
	add	R30,R16
	clr	R16
	adc	R31,R16
	lpm	R16,Z
	mul	R21,R16
	ret
	
	;prekodovani prehravacich rychlosti ((perioda*35)/256)-15
FreqT:	.db	0,1,2,3,4,5,6,6
	.db	7,8,9,9,10,10,11,12
	.db	12,13,13,14,14,15,15,16
	.db	16,17,17,17,18,18,19,19
	.db	19,20,20,20,21,21,21,22
	.db	22,22,23,23,23,24,24,24
	.db	24,25,25,25,25,26,26,26
	.db	27,27,27,27,27,28,28,28
	.db	28,29,29,29,29,29,30,30
	.db	30,30,30,31,31,31,31,31
	.db	31,32,32,32,32,32,32,33
	.db	33,33,33,33,33,34,34,34
	.db	34,34,34,35,35,35,35,35
	;pro arpeggio
	.db	1,255
	.db	1,230
	.db	1,200
	.db	1,176
	.db	1,150
	.db	1,127
FreqNewT:	.db	1,107
	.db	1,86
	.db	1,67
	.db	1,48
	.db	1,31
	.db	1,16
	.db	1,1
	.db	0,241
	.db	0,227
	.db	0,215
	.db	0,203
	.db	0,191
	.db	0,181
	.db	0,170
	.db	0,161
	.db	0,152
	.db	0,144
	.db	0,135
	.db	0,128
	.db	0,121
	.db	0,114
	.db	0,107
	.db	0,101
	.db	0,96
	.db	0,90
	.db	0,85
	.db	0,81
	.db	0,76
	.db	0,72
	.db	0,68
	.db	0,64
	.db	0,60
	.db	0,57
	.db	0,54
	.db	0,51
	.db	0,48
	
;***********************************
;*	IntDiv  24b/24b   *
;***********************************
;Tato rutina neni Float knihovnou pouzita, nicmene se muze hodit.
;Vstup:	RegA2:RegA1:RegA0 - delenec - bude prepsan podilem
;	RegB2:RegB1:RegB0 - delitel - nezmeni se
;Vystup:	RegA2:RegA1:RegA0 - podil
;	RegA5:RegA4:RegA3 - zbytek

	.def	RegA0=R16
	.def	RegA1=R17
	.def	RegA2=R18
	.def	RegB0=R19
	.def	RegB1=R20
	.def	RegB2=R21
	.def	RegA3=R13
	.def	RegA4=R14
	.def	RegA5=R15
		
Div24u:	clr	RegA5	;smazat zbytek
	clr	RegA4
	sub	RegA3,RegA3	;a zaroven Carry

	rol	RegA0	;rotaci delenec do zbytku
	rol	RegA1
	rol	RegA2
	rol	RegA3
	sub	RegA3,RegB0	;pokusit se odecist
	sbc	RegA4,RegB1
	sbc	RegA5,RegB2
	brcc	Div24u_1	;vyslo to, nechat
	add	RegA3,RegB0	;nevyslo to, pricist zpet
	adc	RegA4,RegB1
	adc	RegA5,RegB2

Div24u_1:	rol	RegA0	;rotaci delenec do zbytku
	rol	RegA1
	rol	RegA2
	rol	RegA3
	sub	RegA3,RegB0	;pokusit se odecist
	sbc	RegA4,RegB1
	sbc	RegA5,RegB2
	brcc	Div24u_2	;vyslo to, nechat
	add	RegA3,RegB0	;nevyslo to, pricist zpet
	adc	RegA4,RegB1
	adc	RegA5,RegB2

Div24u_2:	rol	RegA0	;rotaci delenec do zbytku
	rol	RegA1
	rol	RegA2
	rol	RegA3
	sub	RegA3,RegB0	;pokusit se odecist
	sbc	RegA4,RegB1
	sbc	RegA5,RegB2
	brcc	Div24u_3		 ;vyslo to, nechat
	add	RegA3,RegB0	;nevyslo to, pricist zpet
	adc	RegA4,RegB1
	adc	RegA5,RegB2

Div24u_3:	rol	RegA0	;rotaci delenec do zbytku
	rol	RegA1
	rol	RegA2
	rol	RegA3
	sub	RegA3,RegB0	;pokusit se odecist
	sbc	RegA4,RegB1
	sbc	RegA5,RegB2
	brcc	Div24u_4	;vyslo to, nechat
	add	RegA3,RegB0	;nevyslo to, pricist zpet
	adc	RegA4,RegB1
	adc	RegA5,RegB2

Div24u_4:	rol	RegA0	;rotaci delenec do zbytku
	rol	RegA1
	rol	RegA2
	rol	RegA3
	sub	RegA3,RegB0	;pokusit se odecist
	sbc	RegA4,RegB1
	sbc	RegA5,RegB2
	brcc	Div24u_5	;vyslo to, nechat
	add	RegA3,RegB0	;nevyslo to, pricist zpet
	adc	RegA4,RegB1
	adc	RegA5,RegB2

Div24u_5:	rol	RegA0	;rotaci delenec do zbytku
	rol	RegA1
	rol	RegA2
	rol	RegA3
	sub	RegA3,RegB0	;pokusit se odecist
	sbc	RegA4,RegB1
	sbc	RegA5,RegB2
	brcc	Div24u_6	;vyslo to, nechat
	add	RegA3,RegB0	;nevyslo to, pricist zpet
	adc	RegA4,RegB1
	adc	RegA5,RegB2

Div24u_6:	rol	RegA0	;rotaci delenec do zbytku
	rol	RegA1
	rol	RegA2
	rol	RegA3
	sub	RegA3,RegB0	;pokusit se odecist
	sbc	RegA4,RegB1
	sbc	RegA5,RegB2
	brcc	Div24u_7	;vyslo to, nechat
	add	RegA3,RegB0	;nevyslo to, pricist zpet
	adc	RegA4,RegB1
	adc	RegA5,RegB2

Div24u_7:	rol	RegA0	;rotaci delenec do zbytku
	rol	RegA1
	rol	RegA2
	rol	RegA3
	sub	RegA3,RegB0	;pokusit se odecist
	sbc	RegA4,RegB1
	sbc	RegA5,RegB2
	brcc	Div24u_8	;vyslo to, nechat
	add	RegA3,RegB0	;nevyslo to, pricist zpet
	adc	RegA4,RegB1
	adc	RegA5,RegB2

Div24u_8:	rol	RegA0	;rotaci delenec do zbytku
	rol	RegA1
	rol	RegA2
	rol	RegA3
	rol	RegA4
	sub	RegA3,RegB0	;pokusit se odecist
	sbc	RegA4,RegB1
	sbc	RegA5,RegB2
	brcc	Div24u_9	;vyslo to, nechat
	add	RegA3,RegB0	;nevyslo to, pricist zpet
	adc	RegA4,RegB1
	adc	RegA5,RegB2

Div24u_9:	rol	RegA0	;rotaci delenec do zbytku
	rol	RegA1
	rol	RegA2
	rol	RegA3
	rol	RegA4
	sub	RegA3,RegB0	;pokusit se odecist
	sbc	RegA4,RegB1
	sbc	RegA5,RegB2
	brcc	Div24u_10		;vyslo to, nechat
	add	RegA3,RegB0	;nevyslo to, pricist zpet
	adc	RegA4,RegB1
	adc	RegA5,RegB2

Div24u_10:	rol	RegA0	;rotaci delenec do zbytku
	rol	RegA1
	rol	RegA2
	rol	RegA3
	rol	RegA4
	sub	RegA3,RegB0	;pokusit se odecist
	sbc	RegA4,RegB1
	sbc	RegA5,RegB2
	brcc	Div24u_11		;vyslo to, nechat
	add	RegA3,RegB0	;nevyslo to, pricist zpet
	adc	RegA4,RegB1
	adc	RegA5,RegB2

Div24u_11:	rol	RegA0	;rotaci delenec do zbytku
	rol	RegA1
	rol	RegA2
	rol	RegA3
	rol	RegA4
	sub	RegA3,RegB0	;pokusit se odecist
	sbc	RegA4,RegB1
	sbc	RegA5,RegB2
	brcc	Div24u_12	;vyslo to, nechat
	add	RegA3,RegB0	;nevyslo to, pricist zpet
	adc	RegA4,RegB1
	adc	RegA5,RegB2

Div24u_12:	rol	RegA0	;rotaci delenec do zbytku
	rol	RegA1
	rol	RegA2
	rol	RegA3
	rol	RegA4
	sub	RegA3,RegB0	;pokusit se odecist
	sbc	RegA4,RegB1
	sbc	RegA5,RegB2
	brcc	Div24u_13	;vyslo to, nechat
	add	RegA3,RegB0	;nevyslo to, pricist zpet
	adc	RegA4,RegB1
	adc	RegA5,RegB2

Div24u_13:	rol	RegA0	;rotaci delenec do zbytku
	rol	RegA1
	rol	RegA2
	rol	RegA3
	rol	RegA4
	sub	RegA3,RegB0	;pokusit se odecist
	sbc	RegA4,RegB1
	sbc	RegA5,RegB2
	brcc	Div24u_14	;vyslo to, nechat
	add	RegA3,RegB0	;nevyslo to, pricist zpet
	adc	RegA4,RegB1
	adc	RegA5,RegB2

Div24u_14:	rol	RegA0	;rotaci delenec do zbytku
	rol	RegA1
	rol	RegA2
	rol	RegA3
	rol	RegA4
	sub	RegA3,RegB0	;pokusit se odecist
	sbc	RegA4,RegB1
	sbc	RegA5,RegB2
	brcc	Div24u_15	;vyslo to, nechat
	add	RegA3,RegB0	;nevyslo to, pricist zpet
	adc	RegA4,RegB1
	adc	RegA5,RegB2

Div24u_15:	rol	RegA0	;rotaci delenec do zbytku
	rol	RegA1
	rol	RegA2
	rol	RegA3
	rol	RegA4
	sub	RegA3,RegB0	;pokusit se odecist
	sbc	RegA4,RegB1
	sbc	RegA5,RegB2
	brcc	Div24u_16	;vyslo to, nechat
	add	RegA3,RegB0	;nevyslo to, pricist zpet
	adc	RegA4,RegB1
	adc	RegA5,RegB2

Div24u_16:	rol	RegA0	;rotaci delenec do zbytku
	rol	RegA1
	rol	RegA2
	rol	RegA3
	rol	RegA4
	rol	RegA5
	sub	RegA3,RegB0	;pokusit se odecist
	sbc	RegA4,RegB1
	sbc	RegA5,RegB2
	brcc	Div24u_17	;vyslo to, nechat
	add	RegA3,RegB0	;nevyslo to, pricist zpet
	adc	RegA4,RegB1
	adc	RegA5,RegB2

Div24u_17:	rol	RegA0	;rotaci delenec do zbytku
	rol	RegA1
	rol	RegA2
	rol	RegA3
	rol	RegA4
	rol	RegA5
	sub	RegA3,RegB0	;pokusit se odecist
	sbc	RegA4,RegB1
	sbc	RegA5,RegB2
	brcc	Div24u_18	;vyslo to, nechat
	add	RegA3,RegB0	;nevyslo to, pricist zpet
	adc	RegA4,RegB1
	adc	RegA5,RegB2

Div24u_18:	rol	RegA0	;rotaci delenec do zbytku
	rol	RegA1
	rol	RegA2
	rol	RegA3
	rol	RegA4
	rol	RegA5
	sub	RegA3,RegB0	;pokusit se odecist
	sbc	RegA4,RegB1
	sbc	RegA5,RegB2
	brcc	Div24u_19	;vyslo to, nechat
	add	RegA3,RegB0	;nevyslo to, pricist zpet
	adc	RegA4,RegB1
	adc	RegA5,RegB2

Div24u_19:	rol	RegA0	;rotaci delenec do zbytku
	rol	RegA1
	rol	RegA2
	rol	RegA3
	rol	RegA4
	rol	RegA5
	sub	RegA3,RegB0	;pokusit se odecist
	sbc	RegA4,RegB1
	sbc	RegA5,RegB2
	brcc	Div24u_20	;vyslo to, nechat
	add	RegA3,RegB0	;nevyslo to, pricist zpet
	adc	RegA4,RegB1
	adc	RegA5,RegB2

Div24u_20:	rol	RegA0	;rotaci delenec do zbytku
	rol	RegA1
	rol	RegA2
	rol	RegA3
	rol	RegA4
	rol	RegA5
	sub	RegA3,RegB0	;pokusit se odecist
	sbc	RegA4,RegB1
	sbc	RegA5,RegB2
	brcc	Div24u_21	;vyslo to, nechat
	add	RegA3,RegB0	;nevyslo to, pricist zpet
	adc	RegA4,RegB1
	adc	RegA5,RegB2

Div24u_21:	rol	RegA0	;rotaci delenec do zbytku
	rol	RegA1
	rol	RegA2
	rol	RegA3
	rol	RegA4
	rol	RegA5
	sub	RegA3,RegB0	;pokusit se odecist
	sbc	RegA4,RegB1
	sbc	RegA5,RegB2
	brcc	Div24u_22	;vyslo to, nechat
	add	RegA3,RegB0	;nevyslo to, pricist zpet
	adc	RegA4,RegB1
	adc	RegA5,RegB2

Div24u_22:	rol	RegA0	;rotaci delenec do zbytku
	rol	RegA1
	rol	RegA2
	rol	RegA3
	rol	RegA4
	rol	RegA5
	sub	RegA3,RegB0	;pokusit se odecist
	sbc	RegA4,RegB1
	sbc	RegA5,RegB2
	brcc	Div24u_23	;vyslo to, nechat
	add	RegA3,RegB0	;nevyslo to, pricist zpet
	adc	RegA4,RegB1
	adc	RegA5,RegB2

Div24u_23:	rol	RegA0	;rotaci delenec do zbytku
	rol	RegA1
	rol	RegA2
	rol	RegA3
	rol	RegA4
	rol	RegA5
	sub	RegA3,RegB0	;pokusit se odecist
	sbc	RegA4,RegB1
	sbc	RegA5,RegB2
	brcc	Div24u_24	;vyslo to, nechat
	add	RegA3,RegB0	;nevyslo to, pricist zpet
	adc	RegA4,RegB1
	adc	RegA5,RegB2

Div24u_24:	rol	RegA0	;jeste dorotovat podil
	rol	RegA1
	rol	RegA2
	com	RegA0	;je v komplementovanem tvaru
	com	RegA1
	com	RegA2
	ret
	
;*************** HIGH SPEED DIVIDE ********************************
;*
;* Editor: Pavel Borovsky, Czech Republic, Europe 3.6.2000
;* mail: profesor@ti.cz
;* (from Ap.Note AVR200b )
;*
;* "div16u" - 16/16 Bit Unsigned Division
;*
;* This subroutine divides the two 16-bit numbers 
;* "dd8uH:dd8uL" (dividend) and "dv16uH:dv16uL" (divisor). 
;* The result is placed in "dres16uH:dres16uL" and the remainder in
;* "drem16uH:drem16uL".
;* 
;* NEW !!! Number of words	  :150 + return
;* NEW !!! Number of cycles  :126/134/142 (Min/Avg/Max)
;*              
;* Low registers used	:2 (drem16uL,drem16uH)
;* High registers used  :4 (dres16uL/dd16uL,dres16uH/dd16uH,dv16uL,dv16uH)
;*
;***************************************************************************
;***** Subroutine Register Variables
	.def	drem16uL=R14
	.def	drem16uH=R15
	.def	dres16uL=R16
	.def	dres16uH=R17
	.def	dd16uL=R16
	.def	dd16uH=R17
	.def	dv16uL=R18
	.def	dv16uH=R19
	
div16u:	clr	drem16uL	;clear remainder Low byte
	sub	drem16uH,drem16uH	;clear remainder High byte and carry
	rol	dd16uL	;shift left dividend
	rol	dd16uH
	rol	drem16uL	;shift dividend into remainder
	sub	drem16uL,dv16uL	;remainder = remainder - divisor
	sbc	drem16uH,dv16uH	
	brcc	d16u_2	;if result negative
	add	drem16uL,dv16uL	;restore remainder
	adc	drem16uH,dv16uH
d16u_2:	rol	dd16uL	;shift left dividend
	rol	dd16uH
	rol	drem16uL	;shift dividend into remainder
	sub	drem16uL,dv16uL	;remainder = remainder - divisor
	sbc	drem16uH,dv16uH	;
	brcc	d16u_4	;if result negative
	add	drem16uL,dv16uL	;    restore remainder
	adc	drem16uH,dv16uH
d16u_4:	rol	dd16uL	;shift left dividend
	rol	dd16uH
	rol	drem16uL	;shift dividend into remainder
	sub	drem16uL,dv16uL	;remainder = remainder - divisor
	sbc	drem16uH,dv16uH	;
	brcc	d16u_6		;if result negative
	add	drem16uL,dv16uL	;    restore remainder
	adc	drem16uH,dv16uH
d16u_6:	rol	dd16uL		;shift left dividend
	rol	dd16uH
	rol	drem16uL	;shift dividend into remainder
	sub	drem16uL,dv16uL	;remainder = remainder - divisor
	sbc	drem16uH,dv16uH	;
	brcc	d16u_8		;if result negative
	add	drem16uL,dv16uL	;    restore remainder
	adc	drem16uH,dv16uH
d16u_8:	rol	dd16uL		;shift left dividend
	rol	dd16uH
	rol	drem16uL	;shift dividend into remainder
	sub	drem16uL,dv16uL	;remainder = remainder - divisor
	sbc	drem16uH,dv16uH	;
	brcc	d16u_10		;if result negative
	add	drem16uL,dv16uL	;    restore remainder
	adc	drem16uH,dv16uH
d16u_10:	rol	dd16uL		;shift left dividend
	rol	dd16uH
	rol	drem16uL	;shift dividend into remainder
	sub	drem16uL,dv16uL	;remainder = remainder - divisor
	sbc	drem16uH,dv16uH	;
	brcc	d16u_12		;if result negative
	add	drem16uL,dv16uL	;    restore remainder
	adc	drem16uH,dv16uH
d16u_12:	rol	dd16uL		;shift left dividend
	rol	dd16uH
	rol	drem16uL	;shift dividend into remainder
	sub	drem16uL,dv16uL	;remainder = remainder - divisor
	sbc	drem16uH,dv16uH	;
	brcc	d16u_14		;if result negative
	add	drem16uL,dv16uL	;    restore remainder
	adc	drem16uH,dv16uH
d16u_14:	rol	dd16uL		;shift left dividend
	rol	dd16uH
	rol	drem16uL	;shift dividend into remainder
	sub	drem16uL,dv16uL	;remainder = remainder - divisor
	sbc	drem16uH,dv16uH	;
	brcc	d16u_16		;if result negative
	add	drem16uL,dv16uL	;    restore remainder
	adc	drem16uH,dv16uH
d16u_16:	rol	dd16uL		;shift left dividend
	rol	dd16uH
	rol	drem16uL	;shift dividend into remainder
	rol	drem16uH
	sub	drem16uL,dv16uL	;remainder = remainder - divisor
	sbc	drem16uH,dv16uH	;
	brcc	d16u_18		;if result negative
	add	drem16uL,dv16uL	;    restore remainder
	adc	drem16uH,dv16uH
d16u_18:	rol	dd16uL		;shift left dividend
	rol	dd16uH
	rol	drem16uL	;shift dividend into remainder
	rol	drem16uH
	sub	drem16uL,dv16uL	;remainder = remainder - divisor
	sbc	drem16uH,dv16uH	;
	brcc	d16u_20		;if result negative
	add	drem16uL,dv16uL	;    restore remainder
	adc	drem16uH,dv16uH
d16u_20:	rol	dd16uL		;shift left dividend
	rol	dd16uH
	rol	drem16uL	;shift dividend into remainder
	rol	drem16uH
	sub	drem16uL,dv16uL	;remainder = remainder - divisor
	sbc	drem16uH,dv16uH	;
	brcc	d16u_22		;if result negative
	add	drem16uL,dv16uL	;    restore remainder
	adc	drem16uH,dv16uH
d16u_22:	rol	dd16uL		;shift left dividend
	rol	dd16uH
	rol	drem16uL	;shift dividend into remainder
	rol	drem16uH
	sub	drem16uL,dv16uL	;remainder = remainder - divisor
	sbc	drem16uH,dv16uH	;
	brcc	d16u_24		;if result negative
	add	drem16uL,dv16uL	;    restore remainder
	adc	drem16uH,dv16uH
d16u_24:	rol	dd16uL		;shift left dividend
	rol	dd16uH
	rol	drem16uL	;shift dividend into remainder
	rol	drem16uH
	sub	drem16uL,dv16uL	;remainder = remainder - divisor
	sbc	drem16uH,dv16uH	;
	brcc	d16u_26		;if result negative
	add	drem16uL,dv16uL	;    restore remainder
	adc	drem16uH,dv16uH
d16u_26:	rol	dd16uL		;shift left dividend
	rol	dd16uH
	rol	drem16uL	;shift dividend into remainder
	rol	drem16uH
	sub	drem16uL,dv16uL	;remainder = remainder - divisor
	sbc	drem16uH,dv16uH	;
	brcc	d16u_28		;if result negative
	add	drem16uL,dv16uL	;    restore remainder
	adc	drem16uH,dv16uH
d16u_28:	rol	dd16uL		;shift left dividend
	rol	dd16uH
	rol	drem16uL	;shift dividend into remainder
	rol	drem16uH
	sub	drem16uL,dv16uL	;remainder = remainder - divisor
	sbc	drem16uH,dv16uH	;
	brcc	d16u_30		;if result negative
	add	drem16uL,dv16uL	;    restore remainder
	adc	drem16uH,dv16uH
d16u_30:	rol	dd16uL		;shift left dividend
	rol	dd16uH
	rol	drem16uL	;shift dividend into remainder
	rol	drem16uH
	sub	drem16uL,dv16uL	;remainder = remainder - divisor
	sbc	drem16uH,dv16uH	;
	brcc	d16u_32		;if result negative
	add	drem16uL,dv16uL	;    restore remainder
	adc	drem16uH,dv16uH
d16u_32:	rol	dd16uL		;shift left dividend
	rol	dd16uH
	com	dd16uL
	com	dd16uH
	ret	